// flipperball module

int g_iBalls[1500];
int g_iCurrent;
int numPrintedBallFlipper = 0;


public int Flipper_Init() {
	AddToForward(g_OnMapStart, INVALID_HANDLE, Flipper_OnMapStart);
}	

public int Flipper_OnMapStart() {
	PrecacheModel("models/forlix/soccer/soccerball.mdl", true);
}

public int Flipper_OnMinigame() {
	AddToForward(g_justEntered, INVALID_HANDLE, Flipper_justEntered);
	AddToForward(g_OnEndMinigame, INVALID_HANDLE, Flipper_End);
	AddToForward(g_OnGameFrame_Minigames, INVALID_HANDLE, Flipper_OnGameFrame);
	g_BallReady = true;
	if(g_BallReady == true){
		CreateTimer(0.5, Timer_BallSpam, _, TIMER_REPEAT);
	}
}

public int  Flipper_OnGameFrame() {
	for (int i = 1; i <= MaxClients; i++) {
		if (IsValidClient(i) && IsPlayerAlive(i) && IsClientParticipating(i)) {
			float pos[3];
			GetClientAbsOrigin(i, pos);
			if (pos[1] < -5303.0) SetStateClient(i, true, true);
		}
	}
}

public void Flipper_justEntered(int client) {
	g_BallReady = true;
	if (IsValidClient(client)) {		
		float vel[3];
		vel[0] = 0.0;
		vel[1] = 0.0;
		vel[2] = 0.0;
		
		int columnyt = client;
		int rowyt = 0;
		while (columnyt > 9) {
			columnyt = columnyt - 9;
			rowyt = rowyt + 1;
		}
	 
		float pos[3];
		pos[0] = -4331.0 + float(columnyt*55);
		pos[1] = 2112.0 - float(rowyt*55);
		pos[2] = -1510.0;
		
		float ang[3];
		ang[0] = 0.0;
		ang[1] = -90.0;
		ang[2] = 0.0;
		TeleportEntity(client, pos, ang, vel);
		RemoveClientWeapons(client);
		NoCollision(true);
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.5);		
	}
}

public void Flipper_End() {
	char strClassname[50];	
	for(int i=0; i<g_iCurrent; i++)
	{
		if(IsValidEntity(g_iBalls[i]))
		{
			GetEdictClassname(g_iBalls[i], strClassname, sizeof(strClassname));
			if(strcmp(strClassname, "prop_physics") == 0)
			{
				AcceptEntityInput(g_iBalls[i], "Kill");				   
			}
		}
		g_iBalls[i] = 0;
		g_BallReady = false;
	}
	g_iCurrent = 0;
	for (int i = 1; i <= MaxClients; i++) {
		if (IsValidClient(i)) {	
			SDKUnhook(i, SDKHook_OnTakeDamage, Flipper_Hurt);
			SetEntPropFloat(i, Prop_Data, "m_flLaggedMovementValue", 1.0);
		}
	}
	g_BallReady = false;
}
public Action OnTouch(int iBall, int other)
{
	if(other && other <= MaxClients){
		if (IsValidClient(other)) {
			FakeClientCommand(other, "kill");
		}
	}
} 
public Action Timer_BallSpam(Handle timer)
{ 
	if (numPrintedBallFlipper >= 50) {		
		numPrintedBallFlipper = 0;
		return Plugin_Stop;
	}
	if(g_BallReady == true){
		int iBall = CreateEntityByName("prop_physics");
		if(IsValidEntity(iBall)){
			DispatchKeyValue(iBall, "model", "models/forlix/soccer/soccerball.mdl");
			SDKHook(iBall, SDKHook_Touch, OnTouch);	
			DispatchSpawn(iBall);
			int target;
			target = GetRandomPlayer();
			float dynamicpos[3];
			if(IsValidClient(target)){
				GetClientAbsOrigin(target, dynamicpos);
			}
			dynamicpos[1] = -5124.7;
			dynamicpos[2] = 685.2;
			TeleportEntity(iBall, dynamicpos, NULL_VECTOR, NULL_VECTOR);
			g_iBalls[g_iCurrent++] = iBall;		
		}
		numPrintedBallFlipper++;
		return Plugin_Continue;
	}
	return Plugin_Continue;
}
public Action Flipper_Hurt(int victim, int &attacker, int &inflictor, float &damage, int &damagetype) {
	damage = 0.0;
	return Plugin_Changed;
}