// Mandrill module

public int Mandrill_OnMinigame() {
	AddToForward(g_justEntered, INVALID_HANDLE, Mandrill_justEntered);	
	AddToForward(g_OnGameFrame_Minigames, INVALID_HANDLE, Mandrill_OnGameFrame);
	AddToForward(g_PlayerDeath, INVALID_HANDLE, Mandrill_PlayerDeath);
	AddToForward(g_OnEndMinigame, INVALID_HANDLE, Mandrill_End);
	NoCollision(true);
	
}
public int Mandrill_OnGameFrame() {
	for (int i = 1; i <= MaxClients; i++) {
		if (IsValidClient(i) && IsPlayerAlive(i) && IsClientParticipating(i)) {
			float pos[3];
			GetClientAbsOrigin(i, pos);
			if (pos[0] < -10662.0) SetStateClient(i, true, true);
		}
	}
}


public void Mandrill_justEntered(int client) {
	if (IsValidClient(client)) {		
		DisableClientWeapons(client);	
		
		float vel[3];
		vel[0] = 0.0;
		vel[1] = 0.0;
		vel[2] = 0.0;

		float pos[3];
		pos[0] = 2250.513428;
		pos[1] = -8425.510742;
		pos[2] = 2923.0;

		float ang[3];
		ang[0] = 0.0;
		ang[1] = 180.0;
		ang[2] = 0.0;
		TeleportEntity(client, pos, ang, vel);
		NoCollision(true);
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 0.95);
	}
}

public void Mandrill_PlayerDeath(int client) {
	SetStateClient(client, false, true);	 
}
public void Mandrill_End() {
	for (int i = 1; i <= MaxClients; i++) {
		if (IsValidClient(i)) {
			SetEntPropFloat(i, Prop_Data, "m_flLaggedMovementValue", 1.0);
		}
	}
}
