//GiftTarget

#define BOSS_TARGET "models/props/coop_cementplant/exloding_barrel/exploding_barrel_top.mdl"

int g_iBosss[1500];
int g_iCurrentBossTarget;
int iBoss = -1;

public int BossTarget_Init() {
	AddToForward(g_OnMapStart, INVALID_HANDLE, BossTarget_OnMapStart);
}	

public int BossTarget_OnMapStart() {

	//AddFileToDownloadsTable("models/items/tf_gift.mdl");
	PrecacheModel(BOSS_TARGET, true);
}

public int BossTarget_OnMinigame() {
	AddToForward(g_justEntered, INVALID_HANDLE, BossTarget_justEntered);
	AddToForward(g_OnGameFrame_Minigames, INVALID_HANDLE, BossTarget_OnGameFrame);
	AddToForward(g_OnEndMinigame, INVALID_HANDLE, BossTarget_End);
	g_attack = true;
	if(g_StartBoss != INVALID_HANDLE)
	{
		CloseHandle(g_StartBoss);
		g_StartBoss = INVALID_HANDLE;
	}
	g_BossTargetMiniGame = true;
	if(g_BossTargetMiniGame == true){
		g_StartBoss = CreateTimer(2.0, Timer_BossSpam, _, TIMER_REPEAT);
	}
}
public int BossTarget_OnGameFrame() {
	for (int i = 1; i <= MaxClients; i++) {
		if(IsValidClient(i) && IsPlayerAlive(i) && IsClientParticipating(i)) {
			int g_hActiveWeapon = FindSendPropOffs("CCSPlayer", "m_hActiveWeapon");
			int weapon = GetEntDataEnt2(i, g_hActiveWeapon);
			if (IsValidEdict(weapon))
			{
				SetEntPropFloat(weapon, Prop_Send, "m_fAccuracyPenalty", 0.0);
			}	
		}
	}
}
public Action Timer_BossSpam(Handle timer) {
	if(g_BossTargetMiniGame == true){
		int BossPrinted; int LastBoss = 0;
		LastBoss = BossPrinted;
		while(BossPrinted == LastBoss)
		{
			BossPrinted = GetRandomInt(0, 13);
		} 
		if (BossPrinted >= 25) {		
			BossPrinted = 0;
			return Plugin_Stop;
		}
	
		iBoss = CreateEntityByName("prop_physics_override");
		
		if (IsValidEdict(iBoss)) {	
			char model[128];
			Format(model, sizeof(model), BOSS_TARGET);
			
			DispatchKeyValue(iBoss, "model", model);
			//DispatchKeyValue(iBoss, "modelscale", "1.0");
			DispatchKeyValue(iBoss, "solid", "6");
			DispatchSpawn(iBoss);
			SetEntityMoveType(iBoss, MOVETYPE_NONE);
			SDKHook(iBoss, SDKHook_OnTakeDamage, BossTarget_Hurt);

			Target_SetPos();
			BossPrinted++;
			int iBossref = EntIndexToEntRef(iBoss);
			if(IsValidEntity(iBoss)){
				CreateTimer(2.0, Timer_BossKill, iBossref);
			}		
		
		}
		return Plugin_Handled;
	}
	return Plugin_Continue;
}
int Target_SetPos() {
	float angboss[3];
	angboss[0] = 0.0;
	angboss[1] = 270.0;
	angboss[2] = 0.0;	
	switch (GetRandomInt(0, 13))
	{
		case 0:
		{
			float hwB0Loc[3] = {1561.630859, -3725.528076, 120.0};
			TeleportEntity(iBoss, hwB0Loc, angboss, NULL_VECTOR);
		}
		case 1:
		{
			float hwB1Loc[3] = {3036.461914, -3655.968750, 120.0};
			TeleportEntity(iBoss, hwB1Loc, angboss, NULL_VECTOR);
		}
		case 2:
		{
			float hwB2Loc[3] = {2543.535889, -3655.968750, 120.0};
			TeleportEntity(iBoss, hwB2Loc, angboss, NULL_VECTOR);
		}
		case 3:
		{
			float hwB3Loc[3] = {2288.456787, -3895.968750, 120.0};
			TeleportEntity(iBoss, hwB3Loc, angboss, NULL_VECTOR);
		}
		case 4:
		{
			float hwB4Loc[3] = {1719.658081, -3735.968750, 120.0};
			TeleportEntity(iBoss, hwB4Loc, angboss, NULL_VECTOR);
		}
		case 5:
		{
			float hwB5Loc[3] = {2703.139648, -4023.968750, 120.0};
			TeleportEntity(iBoss, hwB5Loc, angboss, NULL_VECTOR);
		}
		case 6:
		{
			float hwB6Loc[3] = {2412.620361, -4014.617188, 120.0};
			TeleportEntity(iBoss, hwB6Loc, angboss, NULL_VECTOR);
		}
		case 7:
		{
			float hwB7Loc[3] = {1776.241943, -4023.968750, 120.0};
			TeleportEntity(iBoss, hwB7Loc, angboss, NULL_VECTOR);
		}
		case 8:
		{
			float hwB8Loc[3] = {2686.875488, -3655.968750, 120.0};
			TeleportEntity(iBoss, hwB8Loc, angboss, NULL_VECTOR);
		}
		case 9:
		{
			float hwB9Loc[3] = {2124.051758, -3895.968750, 120.0};
			TeleportEntity(iBoss, hwB9Loc, angboss, NULL_VECTOR);
		}
		case 10:
		{
			float hwB10Loc[3] = {1758.119263, -3735.999512, 120.0};
			TeleportEntity(iBoss, hwB10Loc, angboss, NULL_VECTOR);
		}
		case 11:
		{
			float hwB11Loc[3] = {1957.286133, -4023.486816, 120.0};
			TeleportEntity(iBoss, hwB11Loc, angboss, NULL_VECTOR);
		}
		case 12:
		{
			float hwB12Loc[3] = {2742.419434, -4021.792480, 120.0};
			TeleportEntity(iBoss, hwB12Loc, angboss, NULL_VECTOR);
		}
		case 13:
		{
			float hwB13Loc[3] = {2185.667236, -3894.608643, 120.0};
			TeleportEntity(iBoss, hwB13Loc, angboss, NULL_VECTOR);
		}
	}

}
public Action Timer_BossKill(Handle timer, any itemkill)
{
	if(IsValidEntity(itemkill))
	{
		SDKUnhook(itemkill, SDKHook_OnTakeDamage, BossTarget_Hurt);
		AcceptEntityInput(itemkill, "Kill");
	}
}
public void BossTarget_End() {
	char strClassname[50];	
	for(int i=0; i<g_iCurrentBossTarget; i++)
	{
		if(IsValidEntity(g_iBosss[i]))
		{
			GetEdictClassname(g_iBosss[i], strClassname, sizeof(strClassname));
			if(strcmp(strClassname, "prop_dynamic_override") == 0)
			{				
				AcceptEntityInput(g_iBosss[i], "Kill");	
			}
		}		
		g_iBosss[i] = -1;
	}	
	for (int i = 1; i <= MaxClients; i++) {
		SDKUnhook(i, SDKHook_OnTakeDamage, BossTarget_HurtClient);
		//g_StartBoss = false;
	}
	g_attack = false;	
	if(g_StartBoss != INVALID_HANDLE)
	{
		CloseHandle(g_StartBoss);
		g_StartBoss = INVALID_HANDLE;
	}
	g_iCurrentBossTarget = -1;
	g_BossTargetMiniGame = false;

}


public Action BossTarget_Hurt(int item, int &attacker, int &inflictor, float &damage, int &damagetype) {
	if(status == 2){
		if(IsValidEntity(item)){
			if(attacker <0 || attacker > MAXPLAYERS)return Plugin_Changed;
			if (g_Complete[attacker] == false){		
				PlaySound2(attacker);
				g_Minipoints[attacker] += 1;
				Panel panel = CreatePanel(GetMenuStyleHandle(MenuStyle_Radio));
				char text[128];
				Format(text,127,"Minipoints: %d - 10", g_Minipoints[attacker]);
				DrawPanelText(panel, text);	
				//AcceptEntityInput(item, "Kill" );
				if (g_Minipoints[attacker] >= 10){ 
					SetStateClient(attacker, true, true);
					Format(text,127,"YOU DID IT!");
					DrawPanelText(panel, text);	
				}
				SendPanelToClient(panel, attacker, csgomenu, 2);		 
				CloseHandle(panel);
			}
		}		
	}
	return Plugin_Changed;
}
public Action BossTarget_HurtClient(int victim, int &attacker, int &inflictor, float &damage, int &damagetype) {
	if(victim <0 || victim > MAXPLAYERS)return Plugin_Changed;
	else
	damage = 0.0;
	return Plugin_Changed;
}
public void BossTarget_justEntered(int client) {
		g_BossTargetMiniGame = true;
		if (IsValidClient(client)) {			
		float vel[3];
		vel[0] = 0.0;
		vel[1] = 0.0;
		vel[2] = 0.0;
		
		int columnas = client;
		int rowas = 0;
		
		float pos[3];
		pos[0] = 1443.321 + float(columnas*63);
		pos[1] = -5256.0 - float(rowas*63);
		pos[2] = 166.0;

		float ang[3];
		ang[0] = 0.0;
		ang[1] = 90.0;
		ang[2] = 0.0;
		TeleportEntity(client, pos, ang, vel);
		RemoveClientWeapons(client);
		GivePlayerItem(client, "weapon_awp");
		int g_hActiveWeapon = FindSendPropOffs("CCSPlayer", "m_hActiveWeapon");
		int weapon = GetEntDataEnt2(client, g_hActiveWeapon);
		int g_iClip1 = FindSendPropOffs("CBaseCombatWeapon", "m_iClip1");
		if (IsValidEdict(weapon))
		{
			SetEntPropFloat(weapon, Prop_Send, "m_fAccuracyPenalty", 0.0);
			SetEntData(weapon, g_iClip1, 20, 4, true);
		}		
		g_Minipoints[client] = 0;				
		
		// No damage
		SDKHook(client, SDKHook_OnTakeDamage, BossTarget_HurtClient);		
	}
}


public void PlaySound2(int client){
	if (IsValidClient(client)){
		EmitSoundToClient(client, SOUND_MINISCORE, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL,GetSoundMultiplier());
	}			 
}
public bool TraceRayHitAnything(int entity, int mask)
{
	// Check if the ray hits an entity, and stop if it does
	if(entity > MaxClients || entity <= MaxClients)
		return true;
	return false;
}