/*
	1:      Speed Up        Everything is faster
	2:      Don't Touch     Touch other players and fail
	3:      x2 Bosses       Two bosses
	4:      Singleplayer    Everyone is invisible
	5:      Worst is Best   The person with the least points win
	6:      Bonk            Everyone gets a bat to push people with    
	7:      Thirdperson     Forced into thirdperson!    
*/

#define SPECIAL_TOTAL 8

bool Special_TwoBosses = false;
char var_special_name[][] = {"SUPER SPEED", "NO TOUCHING", "x2 BOSS BATTLE", "SINGLEPLAYER", "LEAST IS BEST", "BONK", "THIRDPERSON", "FOV EXPERIENCE", "BIG WEAPONS", "IT'S FART TIME!"};
char var_special_desc[][] = {"The Game is Faster Than Usual!!", "Don't Touch Any Enemy Players or You'll Lose!!", "Two Boss Battles!!", "You're Playing Alone...?", "The Player With The Least Points Win!!", "Push Players With Your Bat!!", "Everything Is At A New Perspective!!", "FOV SET TO 110 For All!", "sadly not work for all weaps", "Ops , Sorry man XD"};

public int Special_Spawn(int i)
{
	SetClientFOV(i, 110);
}
int SetClientFOV(int client, int iAmount)
{
	SetEntProp(client, Prop_Send, "m_iFOV", iAmount);
}

public int Special_NoTouch(int entity, int other) {
	if (SpecialRound != 2) return;
	if (StrEqual(minigame, "Hugging")) return;
	if (StrEqual(minigame, "SniperTarget")) return;
	if (StrEqual(minigame, "SoldierTarget")) return;
	if (StrEqual(minigame, "Airblast")) return;
	if (StrEqual(minigame, "Batboy")) return;
	if (StrEqual(minigame, "Mandrill")) return;
	char classname[64];
	char classname2[64];
	GetEdictClassname(entity, classname, sizeof(classname));
	GetEdictClassname(other, classname2, sizeof(classname2));
	if (StrEqual(classname, "player") && StrEqual(classname2, "player") && IsValidClient(entity) && IsValidClient(other) && status == 2 && IsPlayerAlive(entity) && IsPlayerAlive(other) && GetClientTeam(entity) != GetClientTeam(other)) {
		SetStateClient(entity, false, true);
		SetStateClient(other, false, true);
		ForcePlayerSuicide(entity);
		ForcePlayerSuicide(other);
		CPrintToChatEx(entity, other, "You touched: {teamcolor}%N{default}", other);
		CPrintToChat(entity, "In this SPECIAL ROUND, you are {red}not allowed to touch anyone{default}!");
		CPrintToChatEx(other, entity, "You touched: {teamcolor}%N{default}", entity);
		CPrintToChat(other, "In this SPECIAL ROUND, you are {red}not allowed to touch anyone{default}!");
	}
}

public Action Special_DamagePush(int victim, int &attacker, int &inflictor, float &damage, int &damagetype) {
	if (IsValidClient(attacker) && IsValidClient(victim) && SpecialRound == 6) {	
		char Weapon[128];
		GetClientWeapon(attacker, Weapon, sizeof(Weapon));
		if (StrEqual(Weapon, "knife")) {
			damage = 0.0;
			float ang[3];
			float vel[3];
			GetClientEyeAngles(attacker, ang);
			vel[0] -= 300.0 * Cosine(DegToRad(ang[1])) * -1.0;
			vel[1] -= 300.0 * Sine(DegToRad(ang[1])) * -1.0;
			vel[2] += 300.0;
			TeleportEntity(victim, NULL_VECTOR, NULL_VECTOR, vel);
		}
	}
	return Plugin_Changed;
}

int ResetSpecialRoundEffect() {
	if (SpecialRound == 2) {
		for (int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i)) SDKUnhook(i, SDKHook_Touch, Special_NoTouch);
		}
	}
	if (SpecialRound == 6) {
		for (int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i)) SDKUnhook(i, SDKHook_OnTakeDamage, Special_DamagePush);
		}
	}
	if (SpecialRound == 4) {
		NoCollision(false);
		for (int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i)) {
				SetEntityRenderColor(i, 255, 255, 255, 255);
				SetEntityRenderMode(i, RENDER_NORMAL);				
			}
		}
	}
	
	if (SpecialRound == 7) {
		for (int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i) && !IsFakeClient(i)){
			g_bThirdPersonEnabled[i] = false;
			}
		}
	}
	if (SpecialRound == 8) {
		for (int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i)) {
			SDKUnhook(i, SDKHook_PreThink, Special_Spawn);			
			GetEntProp(i, Prop_Send, "m_iDefaultFOV");
			}
		}
	}
}

int AddSpecialRoundEffect() {
	if (SpecialRound == 2) {
		for (int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i)) SDKHook(i, SDKHook_Touch, Special_NoTouch);
		}
	}
	if (SpecialRound == 3) Special_TwoBosses = false;
	if (SpecialRound == 4) {
		NoCollision(true);
		for (int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i)) {
				SetEntityRenderColor(i, 255, 255, 255, 0);
				SetEntityRenderMode(i, RENDER_NONE);				
			}				
		}
	}
	if (SpecialRound == 6) {
		for (int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i)) SDKHook(i, SDKHook_OnTakeDamage, Special_DamagePush);
		}
	}
	if (SpecialRound == 7) {
		for (int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i) && !IsFakeClient(i)){
				g_bThirdPersonEnabled[i] = true;
			}
		}
	}
	if (SpecialRound == 8) {
		for (int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i)) SDKHook(i, SDKHook_PreThink, Special_Spawn);
		}
	}
}
stock int ClearTimer(Handle &timer)
{
	if(timer != INVALID_HANDLE)
	{
		KillTimer(timer);
		timer = INVALID_HANDLE;
	}
}