//Includes:
#include <sourcemod>
#include <clientprefs>
#include <sdktools>
#include <sdktools_sound>
#include emitsoundany.inc
//#include <morecolors>
#include <multicolors>
#include <sdkhooks>
#include <cstrike>
#include <regex> 
#pragma newdecls required

#define MAX_MINIGAMES 27

#define PLUGIN_VERSION "1.04"

#define MUSIC2_START "gamesound/csgoware/csgoware_intro.mp3"
#define MUSIC2_START_LEN 2.18
#define MUSIC2_WIN "gamesound/csgoware/csgoware_win.mp3"
#define MUSIC2_FAIL "gamesound/csgoware/csgoware_fail.mp3"
#define MUSIC2_END_LEN 2.2
#define MUSIC2_SPEEDUP "gamesound/csgoware/csgoware_speedup.mp3"
#define MUSIC2_SPEEDUP_LEN 3.29
#define MUSIC2_BOSS "gamesound/csgoware/boss.mp3"
#define MUSIC2_BOSS_LEN 3.9
#define MUSIC2_GAMEOVER "gamesound/csgoware/warioman_gameover.mp3"
#define MUSIC2_GAMEOVER_LEN 13.17

#define MUSIC_START "gamesound/csgoware/newintro/warioman_intro.mp3"
#define MUSIC_START_LEN 4.4
#define MUSIC_WIN "gamesound/csgoware/newintro/warioman_win.mp3"
#define MUSIC_FAIL "gamesound/csgoware/newintro/warioman_fail.mp3"
#define MUSIC_END_LEN 2.3
#define MUSIC_SPEEDUP "gamesound/csgoware/newintro/warioman_speedup.mp3"
#define MUSIC_SPEEDUP_LEN 7.1
#define MUSIC_BOSS "gamesound/csgoware/warioman_boss.mp3"
#define MUSIC_BOSS_LEN 4.2
#define MUSIC_GAMEOVER "gamesound/csgoware/warioman_gameover.mp3"
#define MUSIC_GAMEOVER_LEN 13.17

#define SOUND_COMPLETE "gamesound/csgoware/complete_me.mp3"
#define SOUND_COMPLETE_YOU "gamesound/csgoware/complete_you.mp3"
#define SOUND_MINISCORE "items/pumpkin_drop.wav"
#define SOUND_HEAVY_KISS "vo/heavy_generic01.mp3"
#define MUSIC_WAITING "gamesound/csgoware/waitingforplayers_new2.mp3"
#define MUSIC_SPECIAL "gamesound/csgoware/specialround.mp3"
#define MUSIC_SPECIAL_LEN 13.5
#define SOUND_SELECT "gamesound/csgoware/select.mp3"

#define SND_CHANNEL_SPECIFIC 32

#define PARTICLE_WIN_BLUE "teleportedin_blue"
#define PARTICLE_WIN_RED "teleportedin_red"
char g_name[MAX_MINIGAMES][24];
Function g_initFuncs[MAX_MINIGAMES];
int	 g_Sprites[MAXPLAYERS + 1];
bool g_bThirdPersonEnabled[MAXPLAYERS+1];
Handle g_ClearWeaps = INVALID_HANDLE;

// Language strings
char var_lang[][] = {"", "it/"};

// Handles
ConVar ww_enable;
ConVar ww_speed;
ConVar ww_music;
ConVar ww_force;
ConVar ww_log;
ConVar ww_special;
ConVar ww_gamemode;
ConVar ww_servercfg;

ConVar ww_force_special;
Handle ww_allowedCommands;
int gVelocityOffset;
Handle clientCookie;
Handle clientVolCookie;
float g_fvol[MAXPLAYERS+1];
Handle LateTimers[MAXPLAYERS+1];

// REPLACE WEAPON
Handle g_hSdkRemoveWearable = INVALID_HANDLE;
Handle microgametimer = INVALID_HANDLE;
static int g_i_EffectDispatchTable;
static int g_i_DecalPrecacheTable;

// Keyvalues configuration handle
Handle MinigameConf = INVALID_HANDLE;
Handle g_StartBoss = INVALID_HANDLE;

// Bools
bool g_Complete[MAXPLAYERS+1];
bool g_Spawned[MAXPLAYERS+1];
bool g_ModifiedOverlay[MAXPLAYERS+1];
bool g_attack = false;
bool g_enabled = false;
bool g_first = false;
bool g_waiting = true;
bool g_SawGameStart = false;
bool g_wipeout_start = false;
bool g_BossTargetMiniGame = false;
bool g_SoldierTargGameStart = false;
bool g_BallReady = false;
bool g_StartTalpa = false;
bool g_MultiJumpEnabled = false;
bool g_PortalStart = false;

// Ints

int g_Mission[MAXPLAYERS+1];
int g_NeedleDelay[MAXPLAYERS+1];
int g_Points[MAXPLAYERS+1];
int g_Id[MAXPLAYERS+1];
int g_Winner[MAXPLAYERS+1];
int g_Minipoints[MAXPLAYERS+1];
int g_Country[MAXPLAYERS+1];
float currentSpeed;
int iMinigame;
int status;
int weaponIndex0;
int weaponIndex1;
int weaponIndex3;
int randommini;
int g_offsCollisionGroup;
int timeleft = 8;
int white;
int g_HaloSprite;
int g_ExplosionSprite;
int g_result = 0;
char g_mathquestion[24];
int Roundstarts = 0;
int g_lastminigame = 0;
int g_lastboss = 0;
int g_minigamestotal = 0;
int bossBattle = 0;
int SpecialRound = 0;
bool g_Participating[MAXPLAYERS+1] = false;
int g_Gamemode = 0;
int OldTeam[MAXPLAYERS+1];
int g_WeaponParent;

// Strings
char materialpath[512] = "ww_overlays/";
// Name of current minigame being played
char minigame[25];
char output2[255];

// VALID iMinigame FORWARD HANDLERS //////////////
Handle g_OnMapStart;
Handle g_justEntered;
Handle g_OnAlmostEnd;
Handle g_OnTimerMinigame;
Handle g_OnEndMinigame;
Handle g_OnGameFrame_Minigames;
Handle g_PlayerDeath;
/////////////////////////////////////////
enum g_ePlayerInfo
{
	g_iPlayerColor[4],
	Handle:g_hPlayerEntities
};
///////////////////////////////////////////////
#define GAMEMODE_NORMAL			0
#define GAMEMODE_WIPEOUT		1
#define GAMEMODE_WIPEOUT_HEIGHT 710.0
#define SOUND_DIR "sound/gamesound/csgoware/"
#define SUBSOUND_DIR "gamesound/csgoware/"

#include csgoware\microgames\hitenemy.inc
#include csgoware\microgames\kamikaze.inc
#include csgoware\microgames\barrel.inc
#include csgoware\microgames\sawrun.inc
#include csgoware\microgames\needlejump.inc
#include csgoware\microgames\hopscotch.inc
#include csgoware\microgames\bosstarget.inc
#include csgoware\microgames\airblast.inc
#include csgoware\microgames\math.inc
#include csgoware\microgames\movement.inc
#include csgoware\microgames\flood.inc
#include csgoware\microgames\soldiertarget.inc
#include csgoware\microgames\bball.inc
#include csgoware\microgames\hugging.inc
#include csgoware\microgames\simonsays.inc
#include csgoware\microgames\redfloor.inc
#include csgoware\microgames\snipertarget.inc
#include csgoware\microgames\jumprope.inc
#include csgoware\microgames\colortext.inc
#include csgoware\microgames\frogger.inc
#include csgoware\microgames\goomba.inc
#include csgoware\microgames\flipperball.inc
#include csgoware\microgames\mandrill.inc
#include csgoware\microgames\catchbarrels.inc
#include csgoware\microgames\multijump.inc
#include csgoware\microgames\portals.inc
#include csgoware\microgames\dodgeball.inc


#include csgoware\mw_csgo_features.inc
#include csgoware\special.inc
#include csgoware\vocalize.inc
//#include csgoware\fireworks.inc

public Plugin myinfo = {
	name = "csgoware",
	author = "TonyBaretta",
	description = "Wario Ware in csgo!",
	version = PLUGIN_VERSION,
	url = "www.wantedgov.it"
};

public void OnPluginStart() {
	// Check for SDKHooks
	if(GetExtensionFileStatus("sdkhooks.ext") < 1)
		SetFailState("SDK Hooks is not loaded.");
	
	// Find collision group offsets
	g_offsCollisionGroup = FindSendPropOffs("CBaseEntity", "m_CollisionGroup");
	if (g_offsCollisionGroup == -1) {
		PrintToServer("* FATAL ERROR: Failed to get offset for CBaseEntity::m_CollisionGroup");
	}
	
	 // ConVars
	CreateConVar("csgoware_version", PLUGIN_VERSION, "Current csgoware version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	ww_enable = CreateConVar("ww_enable", "1", "Enables/Disables TF2 Ware.", FCVAR_PLUGIN);
	ww_force = CreateConVar("ww_force", "0", "Force a certain minigame (0 to not force).", FCVAR_PLUGIN);
	ww_speed = CreateConVar("ww_speed", "1.0", "Speed level.", FCVAR_PLUGIN);
	ww_music = CreateConVar("ww_music_fix", "0", "Apply music fix? Should only be on for localhosts during testing", FCVAR_PLUGIN);
	ww_log = CreateConVar("ww_log", "0", "Log server events?", FCVAR_PLUGIN);
	ww_special = CreateConVar("ww_special", "0", "Next round is Special Round?", FCVAR_PLUGIN);
	ww_gamemode = CreateConVar("ww_gamemode", "0", "Gamemode -1 disable keep it at 0 for now", FCVAR_PLUGIN);
	ww_force_special = CreateConVar("ww_force_special", "0", "Forces a specific Special Round on Special Round", FCVAR_PLUGIN);
	ww_servercfg = CreateConVar("ww_server_cfg", "cfg/server.cfg", "location of your server.cfg", FCVAR_PLUGIN);
	AutoExecConfig(true, "csgoware");
	LoadTranslations("common.phrases.txt");
	LoadTranslations("mw_csgoware.phrases.txt");
	gVelocityOffset = FindSendPropInfo("CBasePlayer", "m_vecVelocity[0]");
	RegConsoleCmd("sm_vol", Command_CVol);
	clientCookie = RegClientCookie("csgoware_wins", "Number of csgoware rounds wins", CookieAccess_Protected);
	clientVolCookie = RegClientCookie("csgoware_client_vol", "Client Volume Pref", CookieAccess_Protected);	
	HookUserMessage(GetUserMessageId("TextMsg"), TextMsg, true);
	
	g_WeaponParent = FindSendPropOffs("CBaseCombatWeapon", "m_hOwnerEntity");
}
public void OnMapStart() {		
	char map[128];
	GetCurrentMap(map, sizeof(map));
	char shostname[256];
	char cfgfolder[128];
 
	ww_servercfg.GetString(cfgfolder, 128);
	ReadServercfg(cfgfolder, "hostname", shostname, sizeof(shostname));
	if (StrContains(map, "mg_csgoware", false) == 0)
	{
		SetConVarBool(ww_enable, true);
		g_enabled = true;
		char name[64];
		Format(name, sizeof(name), "%s Csgoware %s", shostname, PLUGIN_VERSION);
		ServerCommand("hostname %s",name);
	}
	if (StrContains(map, "mg_csgoware", false) == -1)
	{
		SetConVarBool(ww_enable, false);
		g_enabled = false;
		char name[64];
		Format(name, sizeof(name), "%s", shostname);
		ServerCommand("hostname %s",name);
		SetConVarInt(FindConVar("mp_ignore_round_win_conditions"), 0);
		SetConVarInt(FindConVar("mp_death_drop_gun"), 1);
		return;
	}
	if(!ww_enable) 
	{
		return;
	}
	if (g_enabled && GetConVarBool(ww_enable))
	{
		char file[256];
		BuildPath(Path_SM, file, 255, "configs/csgoware.ini");
		Handle fileh = OpenFile(file, "r");
		if (fileh != INVALID_HANDLE)
		{
			char buffer[256];
			char buffer_full[PLATFORM_MAX_PATH];

			while(ReadFileLine(fileh, buffer, sizeof(buffer)))
			{
				TrimString(buffer);
				if ((StrContains(buffer, "//") == -1) && (!StrEqual(buffer, "")))
				{
					PrintToServer("Reading downloads line :: %s", buffer);
					Format(buffer_full, sizeof(buffer_full), "%s", buffer);
					if (FileExists(buffer_full))
					{
						PrintToServer("Precaching %s", buffer);
						PrecacheDecal(buffer, true);
						AddFileToDownloadsTable(buffer_full);
					}
				}
			}
		}	
		// Add server tag
		AddServerTag("csgoware");
			
		// Load minigames
		char imFile[PLATFORM_MAX_PATH];
		BuildPath(Path_SM, imFile, sizeof(imFile), "configs/minigames.cfg");
			
		MinigameConf = CreateKeyValues("Minigames");
		if (FileToKeyValues(MinigameConf, imFile)) {
			PrintToServer("Loaded minigames from minigames.cfg");
				
			KvGotoFirstSubKey(MinigameConf);
			int i=0;
			do	{
					KvGetSectionName(MinigameConf, g_name[KvGetNum(MinigameConf, "id")-1], 64);
					i++;
				}
				while (KvGotoNextKey(MinigameConf)); 
			KvRewind(MinigameConf);
		}
		else {
			PrintToServer("Failed to load minigames.cfg!");
		}
		AddTempEntHook("EffectDispatch", TE_OnEffectDispatch);
		AddTempEntHook("World Decal", TE_OnDecal);
		AddTempEntHook("Entity Decal", TE_OnDecal);
		g_i_EffectDispatchTable = FindStringTable("EffectDispatch");
		g_i_DecalPrecacheTable	= FindStringTable("decalprecache");	

			
			// Add logging
		if (GetConVarBool(ww_log)) {
			LogMessage("//////////////////////////////////////////////////////");
			LogMessage("//					   csgoware LOG					//");
			LogMessage("//////////////////////////////////////////////////////");
		}
			
		// Hooks
		HookConVarChange(ww_enable,StartMinigame_cvar);
		HookEvent("player_death", Player_Death, EventHookMode_Post);
		HookEvent("player_team", Player_Team, EventHookMode_Post);
		HookEvent("round_start", Event_Roundstart, EventHookMode_PostNoCopy);
		HookEvent("player_spawn", OnPlayerSpawned, EventHookMode_Post);
		HookEvent("round_end", Event_Roundend);
		RegAdminCmd("ww_list", Command_list, ADMFLAG_GENERIC, "Lists all the registered, enabled plugins and their ids");
		RegAdminCmd("ww_give", Command_points, ADMFLAG_GENERIC, "Gives you 20 points - You're a winner! (testing feature)");
		RegAdminCmd("ww_event", Command_event, ADMFLAG_GENERIC, "Starts a debugging event");
			
		// Vars
		currentSpeed = GetConVarFloat(ww_speed);
		iMinigame = 1;
		status = 0;
		randommini = 0;
		Roundstarts = 0;
		SetStateAll(false);
		ResetWinners();
		SetMissionAll(0);
			
		// FORWARDS FOR MINIGAMES
		g_OnMapStart = CreateForward(ET_Ignore);
		g_justEntered = CreateForward(ET_Ignore, Param_Cell);
		g_OnAlmostEnd = CreateForward(ET_Ignore);
		g_OnTimerMinigame = CreateForward(ET_Ignore, Param_Cell);
		g_OnEndMinigame = CreateForward(ET_Ignore);
		g_OnGameFrame_Minigames = CreateForward(ET_Ignore);
		g_PlayerDeath = CreateForward(ET_Ignore, Param_Cell);
			
		// MINIGAME REGISTRATION
		RegMinigame("HitEnemy", HitEnemy_OnMinigame);
		RegMinigame("Kamikaze", Kamikaze_OnMinigame);
		RegMinigame("Barrel", Barrel_OnMinigame);
		RegMinigame("SawRun", SawRun_OnMinigame, SawRun_Init);
		RegMinigame("Needlejump", Needlejump_OnMinigame);
		RegMinigame("Hopscotch", Hopscotch_OnMinigame);
		RegMinigame("BossTarget", BossTarget_OnMinigame, BossTarget_Init);
		RegMinigame("Airblast", Airblast_OnMinigame);
		RegMinigame("Math", Math_OnMinigame);
		RegMinigame("Movement", Movement_OnMinigame);
		RegMinigame("Flood", Flood_OnMinigame);
		RegMinigame("SoldierTarget", SoldierTarget_OnMinigame, SoldierTarget_Init);
		RegMinigame("BBall", BBall_OnMinigame);
		RegMinigame("Hugging", Hugging_OnMinigame);
		RegMinigame("SimonSays", SimonSays_OnMinigame);
		RegMinigame("RedFloor", RedFloor_OnMinigame);
		RegMinigame("SniperTarget", SniperTarget_OnMinigame, SniperTarget_Init);
		//RegMinigame("Airraid", Airraid_OnMinigame);
		RegMinigame("JumpRope", JumpRope_OnMinigame);
		RegMinigame("ColorText", ColorText_OnMinigame);
		RegMinigame("Frogger", Frogger_OnMinigame, Frogger_Init);
		RegMinigame("Goomba", Goomba_OnMinigame);
		RegMinigame("Flipperball", Flipper_OnMinigame, Flipper_Init);
		RegMinigame("Mandrill", Mandrill_OnMinigame);
		RegMinigame("CatchBarrels", CatchBarrels_OnMinigame, CatchBarrels_Init);
		RegMinigame("MultiJump", MultiJump_OnMinigame);
		RegMinigame("Portals", Portals_OnMinigame, Portals_Init);
		RegMinigame("Dodgeball", Dodgeball_OnMinigame);

		// CHEATS
		//HookConVarChange(FindConVar("sv_cheats"), OnConVarChanged_SvCheats);
		ww_allowedCommands = CreateArray(64);
		SetCommandFlags("host_timescale", GetCommandFlags("host_timescale") & (~FCVAR_CHEAT));
		SetCommandFlags("phys_timescale", GetCommandFlags("phys_timescale") & (~FCVAR_CHEAT));
		SetCommandFlags("r_screenoverlay", GetCommandFlags("r_screenoverlay") & (~FCVAR_CHEAT));

		RemoveNotifyFlag("mp_friendlyfire");
		PushArrayString(ww_allowedCommands, "host_timescale");
		PushArrayString(ww_allowedCommands, "r_screenoverlay");
		ResetScores();
			
		// Remove Notification Flags
		SetConVarInt(FindConVar("mp_friendlyfire"), 1);
		SetConVarInt(FindConVar("sv_disable_immunity_alpha"), 1);
		SetConVarInt(FindConVar("mp_warmuptime"), 30);
		SetConVarInt(FindConVar("mp_teams_unbalance_limit"), 1);
		SetConVarInt(FindConVar("mp_autoteambalance"), 1);
		SetConVarInt(FindConVar("mp_death_drop_gun"), 0);
		ServerCommand("bot_chatter off");
		ServerCommand("ff_damage_reduction_grenade 0");
		ServerCommand("ff_damage_reduction_grenade_self 0");
		ServerCommand("ff_damage_reduction_other 0");
		ServerCommand("ff_damage_reduction_bullets 0");
		ServerCommand("mp_death_drop_gun 0");
		ServerCommand("mp_respawn_immunitytime 0"); 
		SetConVarInt(FindConVar("sv_disable_immunity_alpha"), 1);
		SetConVarInt(FindConVar("mp_ignore_round_win_conditions"), 1);
			//ServerCommand("sv_tags csgoware, warioware");
			
		if (GetConVarBool(ww_log)) LogMessage("Calling OnMapStart Forward");
			
		Call_StartForward(g_OnMapStart);
		Call_Finish();
			
		precacheSound(MUSIC_START);
		precacheSound(MUSIC_WIN);
		precacheSound(MUSIC_FAIL);
		precacheSound(MUSIC_SPEEDUP);
		precacheSound(MUSIC_BOSS);
		precacheSound(MUSIC_GAMEOVER);
			
		precacheSound(MUSIC2_START);
		precacheSound(MUSIC2_WIN);
		precacheSound(MUSIC2_FAIL);
		precacheSound(MUSIC2_SPEEDUP);
		precacheSound(MUSIC2_BOSS);
		precacheSound(MUSIC2_GAMEOVER);
			
		precacheSound(MUSIC_WAITING);
		precacheSound(MUSIC_SPECIAL);
			
		precacheSound(SOUND_COMPLETE);
		precacheSound(SOUND_COMPLETE_YOU);
		precacheSound(SOUND_MINISCORE);
		precacheSound(SOUND_SELECT);
			
		PrecacheModel("models/props/de_vostok/flower_barrel_snow.mdl", true);
		PrecacheModel("models/props/de_vostok/flower_barrel_snow_p1.mdl", true);
		PrecacheModel("models/props/de_vostok/flower_barrel_snow_p2.mdl", true);
		PrecacheModel("models/props/de_vostok/flower_barrel_snow_p3.mdl", true);
		PrecacheModel("models/props/de_vostok/flower_barrel_snow_p4.mdl", true);
		PrecacheModel("models/props/de_vostok/flower_barrel_snow_p5.mdl", true);
		PrecacheModel("models/props/de_vostok/flower_barrel_snow_p6.mdl", true);
		PrecacheModel("models/props/de_vostok/flower_barrel_snow_p7.mdl", true);
		PrecacheModel("models/props/de_vostok/flower_barrel_snow_p8.mdl", true);
		PrecacheModel("models/props/de_vostok/flower_barrel_snow_p9.mdl", true);
		PrecacheModel("models/props/de_vostok/flower_barrel_snow_p10.mdl", true);
		PrecacheModel("models/props/de_vostok/flower_barrel_snow_p11.mdl", true);
			
			
		PrecacheModel("models/props_2fort/cow001_reference.mdl", true);
		PrecacheModel("models/props_forest/sawblade_moving.mdl", true);
			
		PrecacheModel("models/props_vehicles/train_enginecar.mdl");
		PrecacheModel("models/player/demo.mdl");
			
		PrecacheModel("models/humans/group01/female_01.mdl", true); //Simple_bots default model
		PrecacheModel("models/props_halloween/ghost.mdl", true);	//Ghost model itself
		PrecacheModel("ghost_appearation", true);					//Ghost appear & disappear particle
			
		PrecacheModel("models/props_manor/doorframe_01_door_01.mdl", true);
		PrecacheModel("models/props_gameplay/sign_wood_cap001.mdl", true);
			
		PrecacheModel("models/props_training/target_heavy.mdl", true);
		PrecacheModel("models/props/metal_box.mdl", true);
		PrecacheModel("models/props_halloween/hwn_kart_ball01.mdl", true);
		PrecacheModel("models/player/geavy.mdl", true);
			
		PrecacheGeneric("materials/ww_overlays/...", true);
		AddFileToDownloadsTable("materials/ww_overlays/...");
		PrecacheModel( "models/weapons/...", true);
			
		char input[512];

		KvGotoFirstSubKey(MinigameConf);
		int id;
		int enable;
		int i=1;
		if (GetConVarBool(ww_log))
		{
			LogMessage("--Adding the following to downloads table from information in minigames.cfg:", input);
		}
		do
		{
			id = KvGetNum(MinigameConf, "id");
			enable = KvGetNum(MinigameConf, "enable", 1);
			if (enable == 1)
			{
				Format(input, sizeof(input), "gamesound/csgoware/minigame_%d.mp3", id);
				if (GetConVarBool(ww_log))
				{
					LogMessage("%s", input);
				}
				precacheSound(input);
			}
			i++;
		}while (KvGotoNextKey(MinigameConf)); 

		KvRewind(MinigameConf);
			
		white = PrecacheModel("materials/sprites/white.vmt");
		g_HaloSprite = PrecacheModel("materials/sprites/halo01.vmt");
		g_ExplosionSprite = PrecacheModel("sprites/sprite_fire01.vmt");
		PrecacheSoundAny( "ambient/explosions/explode_8.wav", true);
		SetConVarFloat(ww_speed, 1.0);
		ResetScores();
		bossBattle = 0;
		Roundstarts = 0;		
		if (GetConVarBool(ww_log)) LogMessage("Map started");
		ClearTimer(g_ClearWeaps);
		CreateTimer(1.0, CheckTimelimit, INVALID_HANDLE, TIMER_REPEAT);
		g_ClearWeaps = CreateTimer(25.0, Kill_weapons, _, TIMER_REPEAT);
		CreateTimer(30.0, RemoveWarmup);
	}
}

public Action Timer_DisplayVersion(Handle timer, any client)
{
	if (IsValidClient(client))
	{
		CPrintToChat(client, "\x04 CSGOWARE v.%s \x01 by TonyBaretta", PLUGIN_VERSION);
	}
	return Plugin_Handled;
}
public Action Event_Roundstart(Event event,const char[] name,bool dontBroadcast) {
	if (g_enabled && GetConVarBool(ww_enable)) {
		if(GameRules_GetProp("m_bWarmupPeriod") == 1)
		{
			g_waiting = true;
			SetGameMode();
			RemoveAllParticipants();
			ResetWinners();
			ResetScores();
			for(int i = 1; i <= MaxClients; i++) {
				if (IsValidClient(i)) {
					SetOverlay(i, "csgoware_welcome_2");
					EmitSoundToClientAny(i, MUSIC_WAITING, SOUND_FROM_PLAYER, SND_CHANNEL_SPECIFIC, _, _, g_fvol[i]);
				}
			}
			status = 5;
			CreateTimer(0.1, Restartall_timer);
		}
		if(GameRules_GetProp("m_bWarmupPeriod") == 0)
		{
			g_waiting = false;
			SetGameMode();
			ResetScores();
			StartMinigame();
			for(int i = 1; i <= MaxClients; i++) {
				if (IsValidClient(i) && g_Spawned[i]) {
					if (!IsFakeClient(i)) {
						StopSound(i, SND_CHANNEL_SPECIFIC, MUSIC_WAITING);
						SetOverlay(i, "");					
					}
					if (g_Gamemode == GAMEMODE_WIPEOUT) {
							SetWipeoutPosition(i, true);
							if(IsFakeClient(i)){
							ServerCommand("tf_bot_quota 1");					
						 }
					}
				}
			}
			if (GetConVarBool(ww_log)) LogMessage("Waiting-for-players period has ended");
		}
	}
	Roundstarts++;
}

public Action Event_Roundend(Event event,const char[] name,bool dontBroadcast) {
	if (g_enabled && GetConVarBool(ww_enable)) {
		int MapTime = GetConVarInt(FindConVar("mp_timelimit"));
		if (MapTime > 2)
		{
			return;		
		}
		if(MapTime < 1){
			g_enabled = false;
			if (GetConVarBool(ww_log)) LogMessage("== ROUND ENDED SUCCESSFULLY == ");
			ServerCommand("ww_gamedescription 0.0");
			ServerCommand("ww_enable 0");
			for (int i = 1; i <= MaxClients; i++) {
				if (IsValidClient(i) && (!(IsFakeClient(i)))) {
					SetOverlay(i,"csgoware_minigame_gameover");
				}
			}
		}
		ClearTimer(g_ClearWeaps);
	}
}
public Action CS_OnTerminateRound(float &delay, CSRoundEndReason &reason)
{
	return Plugin_Continue;
}
public void OnClientPostAdminCheck(int client) {
	if (!g_enabled) return;
	g_Points[client] = GetAverageScore();
	if (g_Gamemode == GAMEMODE_WIPEOUT) g_Points[client] = -1;
	// Country
	char ip[32];
	GetClientIP(client, ip, sizeof(ip));
	g_Country[client] = 0;
	
	//if (StrEqual(country, "IT")) g_Country[client] = 1;
	if (GetConVarBool(ww_log)) LogMessage("Client post admin check. Country: %d", g_Country[client]);
}

public void OnClientPutInServer(int client) {
	if (!g_enabled) return;
	if (GetConVarBool(ww_log)) LogMessage("Client put in server and hooked");
	SDKHook(client, SDKHook_PreThink, OnPreThink);
	SDKHook(client, SDKHook_OnTakeDamage, Special_DamagePush);
	SDKHook(client, SDKHook_OnTakeDamage, OnTakeDamageClient); 
	SDKHook(client, SDKHook_PostThink, OnPostThink);
	LoadClientCookiesFor(client);
	CPrintToChat(client, "\x04CSGOWARE v.%s \x01by \x03 TonyBaretta", PLUGIN_VERSION);
	if (bossBattle == 1){
		if (IsValidClient(client) && (!(IsFakeClient(client)))) {
			SetOverlay(client,"csgoware_waitboss_2");
		}
	}
	if (bossBattle == 0){
		if (IsValidClient(client) && (!(IsFakeClient(client)))) {
			SetOverlay(client,"csgoware_welcome_2");
		}
	}
}
public int LoadClientCookiesFor(int client)
{
	char buffer[5];
	GetClientCookie(client,clientVolCookie,buffer,5);
	if(!StrEqual(buffer,""))
	{
		g_fvol[client] = StringToFloat(buffer);
	}
	if(StrEqual(buffer,"")){
		g_fvol[client] = 0.8;
	}
}
public void OnClientDisconnect(int client) {
	if (GetConVarBool(ww_log)) LogMessage("Client disconnected");
	DestroySprite(client);
}
public Action Command_CVol(int client,int args)
{
	if (IsValidClient(client)){
		char arg[20];
		float volume;
		if (args < 1)
		{
			CPrintToChat(client,"{green}[CSGOWARE] {default}Volume values {red}0.2 - 1.0");
			return Plugin_Handled;
		}
			
		GetCmdArg(1, arg, sizeof(arg));
		volume = StringToFloat(arg);
		if (volume < 0.2 || volume > 1.0)
		{
			CPrintToChat(client,"{green}[CSGOWARE] {default}Volume values {red}0.2 - 1.0");
			return Plugin_Handled;
		}
		g_fvol[client] = StringToFloat(arg);		
		SetClientCookie(client, clientVolCookie, arg);
	}
	return Plugin_Handled;
}
public int OnPostThink(int client)
{
	int ent; float vOrigin[3]; float vVelocity[3];
	
	for(int i = 1; i <= MaxClients; i++)
	{
		if (!IsClientInGame(i)) continue;
		if ((ent = g_Sprites[i]) > 0)
		{
			if (!IsValidEntity(ent))
				g_Sprites[i] = 0;
			else
			if ((ent = EntRefToEntIndex(ent)) > 0){
				GetClientEyePosition(i, vOrigin);
				vOrigin[2] += 25.0;
				GetEntDataVector(i, gVelocityOffset, vVelocity);
				TeleportEntity(ent, vOrigin, NULL_VECTOR, vVelocity);
			}
		}
	}
}

public Action OnTakeDamageClient(int victim, int &attacker, int &inflictor, float &damage, int &damagetype) {
	
	if ((g_Winner[victim] >= 1) && (status != 2)) {
		damage = 0.0;
		return Plugin_Changed;
	}
	
	if (IsValidClient(attacker) && (g_Winner[attacker] == 1) && (g_Winner[victim] == 0) && IsValidClient(victim) && IsPlayerAlive(victim)) {
		damage = 750.0;
		return Plugin_Changed;
	}
	return Plugin_Continue;
}

public int OnPreThink(int client) {
	int iButtons = GetClientButtons(client);
	float fVelplayer[ 3 ];
	GetEntPropVector(client, Prop_Data, "m_vecVelocity", fVelplayer);
	if ((status != 2) && GetConVarBool(ww_enable) && g_enabled && (g_Winner[client] == 0) && !(SpecialRound == 6 && status != 5))
	{
		if ((iButtons & IN_ATTACK2) || (iButtons & IN_ATTACK))
		{
			iButtons &= ~IN_ATTACK;
			iButtons &= ~IN_ATTACK2;
			SetEntProp(client, Prop_Data, "m_nButtons", iButtons);
		}
	}	
	if ((status == 2) && (g_attack == false || !IsClientParticipating(client)) && GetConVarBool(ww_enable) && g_enabled)
	{
		if ((iButtons & IN_ATTACK2) || (iButtons & IN_ATTACK))
		{
			iButtons &= ~IN_ATTACK;
			iButtons &= ~IN_ATTACK2;
			SetEntProp(client, Prop_Data, "m_nButtons", iButtons);
		}
	}
}
public Action OnPlayerRunCmd(int client, int &buttons, int &Impulse, float Vel[3], float Angles[3], int &Weapon)
{
	int iButtons = GetClientButtons(client);
	if ((status != 2) && GetConVarBool(ww_enable) && g_enabled && (g_Winner[client] == 0) && !(SpecialRound == 6 && status != 5))
	{
		if ((iButtons & IN_ATTACK2) || (iButtons & IN_ATTACK))
		{
			iButtons &= ~IN_ATTACK;
			iButtons &= ~IN_ATTACK2;
			SetEntProp(client, Prop_Data, "m_nButtons", iButtons);
		}
	}	
	if ((status == 2) && (g_attack == false || !IsClientParticipating(client)) && GetConVarBool(ww_enable) && g_enabled)
	{
		if ((iButtons & IN_ATTACK2) || (iButtons & IN_ATTACK))
		{
			iButtons &= ~IN_ATTACK;
			iButtons &= ~IN_ATTACK2;
			SetEntProp(client, Prop_Data, "m_nButtons", iButtons);
		}
	}
	if (StrEqual(minigame, "MultiJump")){
		if ((status == 2) && (g_MultiJumpEnabled))
		{
			if ((iButtons & IN_JUMP))
			{
				BoostJump(client);
				iButtons &= ~IN_JUMP;
			}
		}
	}
	return Plugin_Continue;
}
public Action OnPlayerSpawned(Event event, const char[] name, bool dontBroadcast)
{
	int userid = GetEventInt(event, "userid");
	int client = GetClientOfUserId(userid);
	if (!IsValidClient(client))
	{
		return;
	}
	if (GetConVarBool(ww_log)) LogMessage("Client post inventory");
	if (g_Spawned[client] == false && g_waiting && GetConVarBool(ww_enable) && g_enabled && !IsFakeClient(client)) {
		EmitSoundToClientAny(client, MUSIC_WAITING, SOUND_FROM_PLAYER, SND_CHANNEL_SPECIFIC, _, _, g_fvol[client]);
		SetOverlay(client, "csgoware_welcome_2");
		CreateTimer(0.25, Timer_DisplayVersion, client);
	}

	g_Spawned[client] = true;
	if (GetConVarBool(ww_enable) && g_enabled) {
		SetEntityRenderMode(client, RENDER_NORMAL);
		SetEntityRenderColor(client, 255, 255, 255, 255);
	
		if ((status != 2) && (g_Winner[client] == 0)) {
			DisableClientWeapons(client);
		}
		if (status == 2 && IsClientParticipating(client)) {
			Call_StartForward(g_justEntered);
			Call_PushCell(client);
			Call_Finish();
			CreateSprite(client);
		}		
		if ((status == 2 && g_attack) || (g_Winner[client] > 0) || (SpecialRound == 6)) SetWeaponState(client, true);
		else SetWeaponState(client, false);
		
		//HandlePlayerItems(client);
		
		if (SpecialRound == 4) {
			SetEntityRenderMode(client, RENDER_TRANSCOLOR);
			SetEntityRenderColor(client, 255, 255, 255, 0);
		}
		if (SpecialRound == 8) {
			SDKHook(client, SDKHook_PreThink, Special_Spawn);
		}		
		if (g_Gamemode == GAMEMODE_WIPEOUT && g_waiting == false) {
			if (status == 2 && IsClientParticipating(client)) {
				// do nothing
			}
			else {
				SetWipeoutPosition(client, true);
			}
			HandleWipeoutLives(client);
		}
	}
}

int precacheSound(char[] Svar) {
	char buffer[128];
	PrecacheSoundAny(Svar, true);
	Format(buffer, sizeof(buffer), "sound/%s", Svar);
	AddFileToDownloadsTable(buffer);
}

public int StartMinigame_cvar(Handle cvar, const char[] oldVal, const char[] newVal){
	if (GetConVarBool(ww_enable) && g_enabled) {
		StartMinigame();
		SetConVarInt(FindConVar("mp_respawnwavetime"), 199);
		SetConVarInt(FindConVar("mp_forcecamera"), 0);
	}
	else {
		SetCommandFlags("host_timescale", GetCommandFlags("host_timescale") & (~FCVAR_CHEAT));
		SetCommandFlags("phys_timescale", GetCommandFlags("phys_timescale") & (~FCVAR_CHEAT));
		ServerCommand("host_timescale %f", 1.0);
		ServerCommand("sm_cvar phys_timescale %f", 1.0);
		ResetConVar(FindConVar("mp_respawnwavetime")); 
		ResetConVar(FindConVar("mp_forcecamera")); 
		status = 0;
	}
}

public void OnGameFrame()
{
	if (GetConVarBool(ww_enable) && g_enabled && (status == 2) && (g_OnGameFrame_Minigames != INVALID_HANDLE))
	{
		Call_StartForward(g_OnGameFrame_Minigames);
		Call_Finish();
		//GetConVarBool(g_hdisabletaunts);
		
		if (g_Gamemode == GAMEMODE_WIPEOUT && status == 1)
		{
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i) && IsPlayerAlive(i) && IsClientParticipating(i))
				{
					float pos[3];
					GetClientAbsOrigin(i, pos);
					pos[2] -= 25.0;
					if (pos[2] < GAMEMODE_WIPEOUT_HEIGHT)
					{
						pos[2] = GAMEMODE_WIPEOUT_HEIGHT;
					}
					TeleportEntity(i, pos, NULL_VECTOR, NULL_VECTOR);
				}
			}
		}		
	}
}

public Action StartMinigame_timer(Handle hTimer) {
	if (status == 0) {
		StartMinigame();
	}
	return Plugin_Stop;
}

public Action StartMinigame_timer2(Handle hTimer) {
	if (status == 10) {
		status = 0;
		StartMinigame();
	}
	return Plugin_Stop;
}

int RollMinigame()
{
	if (GetConVarBool(ww_log) && bossBattle != 1)
	{
		LogMessage("Rolling normal microgame...");
	}
	if (GetConVarBool(ww_log) && bossBattle == 1)
	{
		LogMessage("Rolling boss microgame...");
	}
	Handle roll = CreateArray();
	bool accept = false;
	int out = 1;
	int iplayers = GetActivePlayers();
	for (int i = 1; i <= sizeof(g_name); i++)
	{
		if (StrEqual(g_name[i-1], ""))
		{
			continue;
		}
		accept = true;
		int gameisboss = GetMinigameConfNum(g_name[i-1], "boss", 0);
		int minplayers = GetMinigameConfNum(g_name[i-1], "minplayers", 1);
		int maxplayers = GetMinigameConfNum(g_name[i-1], "maxplayers", 2);
		//PrintToChatAll("max , %i min, %i", maxplayers , minplayers);
		if(iplayers > maxplayers)
		{
			accept = true;
		}
		if (iplayers < minplayers)
		{
			accept = false;
		}
		if ((bossBattle == 1) && (!gameisboss))
		{
			accept = false;
		}
		if ((bossBattle != 1) && (gameisboss))
		{
			accept = false;
		}
		if (i == g_lastminigame)
		{
			accept = false;
		}
		if (i == g_lastboss)
		{
			accept = false;
		}
		if (!GetMinigameConfNum(g_name[i-1], "enable", 1))
		{
			accept = false;
		}
		for (int j=0; j<GetMinigameConfNum(g_name[i-1], "chance", 1); j++)
		{
			if (accept)
			{
				PushArrayCell(roll, i);
			}
		}
		if (GetConVarBool(ww_log) && (accept))
		{
			LogMessage("-- Microgame #%d allowed", i);
		}
		if (GetConVarBool(ww_log) && (accept == false))
		{
			LogMessage("-- Microgame #%d NOT allowed", i);
		}
	}
	if (GetArraySize(roll) > 0)
	{
		out = GetArrayCell(roll, GetRandomInt(0, GetArraySize(roll)-1));
		//PrintToChatAll("ID %i", out);
	}
	CloseHandle(roll);
	
	int force = GetConVarInt(ww_force);
	if (force > 0)
	{
		if (force-1 < sizeof(g_name) && !StrEqual(g_name[force-1], ""))
		{
			out = GetConVarInt(ww_force);
		}
		else
		{
			PrintToServer("Warning: Couldn't find a game with id %d, continuing with random roll.", GetConVarInt(ww_force));
		}
	}
	
	if (GetConVarBool(ww_log))
	{
		LogMessage("Rolled microgame was: %s (id:%d)", g_name[out-1], out);
	}
	
	if (GetConVarBool(ww_log))
	{
		LogMessage("Roll end");
	}
	return out;
}

public void Player_Team(Event event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	int oldteam = GetEventInt(event, "oldteam");
	int newteam = GetEventInt(event, "team");
	
	if (GetConVarBool(ww_log))
	{
		LogMessage("%N changed team", client);
	}
	if (GetConVarBool(ww_enable) && g_enabled)
	{
		CreateTimer(0.1, StartMinigame_timer);
		if (oldteam < 2 && newteam >= 2)
		{
			GiveSpecialRoundInfo();
		}
	}
}

int HandOutPoints()
{
	if (GetConVarBool(ww_log))
	{
		LogMessage("Handing out points");
	}
	for (int i = 1; i <= MaxClients; i++)
	{
		int points = 1;
		if ((IsValidClient(i)) && IsClientParticipating(i))
		{
			if (g_Complete[i])
			{
				if (g_Gamemode == GAMEMODE_NORMAL)
				{
					if (bossBattle == 1)
					{
						/* Set the points to 5. */
						points = 5;
					}
					g_Points[i] += points;
				}
			}
			else
			{
				if (g_Gamemode == GAMEMODE_WIPEOUT && g_Points[i] > 0)
				{
					g_Points[i] -= points;
					if (g_Points[i] < 0)
					{
						g_Points[i] = 0;
					}
					HandleWipeoutLives(i, true);
				}
			}
		}
		g_Complete[i] = false;
	}
}

int StartMinigame() {
	if (GetConVarBool(ww_enable) && g_enabled && (status == 0) && g_waiting == false)
	{
		if (GetConVarBool(ww_log))
		{
			LogMessage("Starting microgame %s! Status = 0", minigame);
		}
		SetConVarInt(FindConVar("mp_respawnwavetime"), 199);
		SetConVarInt(FindConVar("mp_friendlyfire"), 1);
		
		float MUSIC_INFO_LEN = MUSIC_START_LEN;
		char MUSIC_INFO[PLATFORM_MAX_PATH];
		Format(MUSIC_INFO, sizeof(MUSIC_INFO), MUSIC_START);
		if (g_Gamemode == GAMEMODE_WIPEOUT)
		{
			MUSIC_INFO_LEN = MUSIC2_START_LEN;
			Format(MUSIC_INFO, sizeof(MUSIC_INFO), MUSIC2_START);
		}
		//RespawnAll();
		for (int i = 1; i <= MaxClients; i++) {
			if(IsValidClient(i) && !IsPlayerAlive(i) && IsClientParticipating(i)){
				//RespawnClient(i, false, false);
				RespawnClientGeneric(i);
			}
		}
		RemoveAllParticipants();
		UpdateHud(GetSpeedMultiplier(MUSIC_INFO_LEN));
		if (SpecialRound == 4)
		{
			NoCollision(true);
		}

		currentSpeed = GetConVarFloat(ww_speed);
		SetCommandFlags("host_timescale", GetCommandFlags("host_timescale") & (~FCVAR_CHEAT));
		SetCommandFlags("phys_timescale", GetCommandFlags("phys_timescale") & (~FCVAR_CHEAT));
		ServerCommand("host_timescale %f", GetHostMultiplier(1.0));
		ServerCommand("sm_cvar phys_timescale %f", GetHostMultiplier(1.0));
		
		if (g_Gamemode == GAMEMODE_WIPEOUT)
		{
			// Get two people to fight it off
			int personA = GetRandomWipeoutPlayer();
			if (IsValidClient(personA))
			{
				g_Participating[personA] = true;
			}
			int personB = GetRandomWipeoutPlayer();
			if (IsValidClient(personB))
			{
				g_Participating[personB] = true;
			}
			
			int personC = -1;
			if (GetLeftWipeoutPlayers() > 4) personC = GetRandomWipeoutPlayer();
			if (IsValidClient(personC)) g_Participating[personC] = true;
			int TeamRed = GetActivePlayers(2, true);
			int TeamBlu = GetActivePlayers(3, true);
			if(TeamRed == 0){
				if (IsValidClient(personA))
				{
					ChangeClientTeamAlive(personA ,2);
				}				
			}
			if(TeamBlu == 0){
				if (IsValidClient(personA))
				{
					ChangeClientTeamAlive(personA ,3);
				}				
			}			
			if (IsValidClient(personA) == false || IsValidClient(personB) == false)
			{
				status = 4;
				bossBattle = 2;
				CreateTimer(GetSpeedMultiplier(MUSIC_INFO_LEN), Victory_timer);
				return;
			}
			char strMessage[512];
			Format(strMessage, sizeof(strMessage), "%N\n%N", personA, personB);
			
			if (IsValidClient(personC))
			{
				Format(strMessage, sizeof(strMessage), "%s\n%N", strMessage, personC);
			}
			PrintCenterTextAll(strMessage);
		}
		else
		{
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i) && GetClientTeam(i) >= 2 && g_Spawned[i] == true)
				{
					g_Participating[i] = true;
				}
			}
		}
		
		//if (GetConVarBool(ww_music)) EmitSoundToClient(1, MUSIC_INFO, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL,GetSoundMultiplier());
		//else EmitSoundToAll(MUSIC_INFO, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL,GetSoundMultiplier());
		
		for (int i = 1; i <= MaxClients; i++)
		{
			DataPack pack;
			LateTimers[i] = CreateDataTimer(0.2, timer_playlate, pack);
			pack.WriteCell(i);
			pack.WriteString(MUSIC_INFO);
			if (IsValidClient(i) && (!(IsFakeClient(i))))
			{
				SetOverlay(i,"");
				g_Minipoints[i] = 0;
			}
			if (g_Gamemode == GAMEMODE_WIPEOUT){
				if (IsValidClient(i) && (!(IsFakeClient(i)))){
					if(g_wipeout_start){
						SetOverlay(i,"csgoware_wipeout");
						//PrintToChatAll("debug wipeout overlay Check");
					}
				}
			}
		}
		
		status = 1;
		iMinigame = RollMinigame();
		if(iMinigame <= 0){
			iMinigame = RollMinigame();
		}
		minigame = g_name[iMinigame-1];
		if (bossBattle == 1) g_lastboss = iMinigame;
		else g_lastminigame = iMinigame;
		CreateTimer(GetSpeedMultiplier(MUSIC_INFO_LEN), Game_Start);
		if (SpecialRound == 6) g_attack = true;
		else g_attack = false;
		DestroyAllSprites();
	}
}

public Action Game_Start(Handle hTimer) {
	if (status == 1) {
		if (GetConVarBool(ww_log)) LogMessage("Microgame %s started! Status = 1", minigame);
		
		// Spawn everyone so they can participate
		//RespawnAll();
		for (int i = 1; i <= MaxClients; i++) {
			if(IsValidClient(i) && !IsPlayerAlive(i) && IsClientParticipating(i)){
				RespawnClientGeneric(i);
			}
		}
		if (SpecialRound == 4) NoCollision(true);
		if (SpecialRound == 7) {
			for (int i = 1; i <= MaxClients; i++) {
				if (IsValidClient(i) && !IsFakeClient(i)) {
					g_bThirdPersonEnabled[i] = true;
				}
			}
		}		
		
		if (g_Gamemode == GAMEMODE_WIPEOUT) {
			for (int i2 = 1; i2 <= MaxClients; i2++) {
				if (IsValidClient(i2) && IsPlayerAlive(i2) && IsClientParticipating(i2)) {
					SetEntityMoveType(i2, view_as<MoveType>(MOVETYPE_WALK));
					SetWipeoutPosition(i2, false);
				}
			}
		}
		// Play the microgame's music
		char sound[512];
		char buffer_s[512];
		Format(sound, sizeof(sound), "gamesound/csgoware/minigame_%d.mp3", iMinigame);
		Format(buffer_s, sizeof(buffer_s), "sound/%s", sound);
		PrecacheSoundAny(buffer_s, true);
		if (StrEqual(minigame, "Ghostbusters") && GetRandomInt(1,3) == 1) Format(sound, sizeof(sound), "gamesound/csgoware/minigame_%d_alt.mp3", iMinigame);
		//if (StrEqual(minigame, "BossTarget")) Format(sound, sizeof(sound), "gamesound/csgoware/minigame_%d.wav", iMinigame);
		int channel = SNDCHAN_AUTO;
		if (GetMinigameConfNum(minigame, "dynamic", 1)) channel = SND_CHANNEL_SPECIFIC;
		if (GetConVarBool(ww_music)) EmitSoundToClient(1, sound, SOUND_FROM_PLAYER, channel, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL,GetSoundMultiplier());
		else {
			for(int i = 1; i <= MaxClients; i++) {
				if(IsValidClient(i)){
					EmitSoundToClientAny(i, sound, SOUND_FROM_PLAYER, channel, SNDLEVEL_NORMAL, SND_NOFLAGS, g_fvol[i],GetSoundMultiplier());
				}
			}
		}
		// Set everyone's state to fail
		SetStateAll(false);
		
		// The 'x did y first' is untriggered
		g_first = false;
		
		// current proccess
		status = 2;
		
		// Reset everyone's mission
		SetMissionAll(0);
		
		// noone can attack
		if (SpecialRound == 6) g_attack = true;
		else g_attack = false;
		
		// initiate mission
		InitMinigame(iMinigame);
		
		// show the mission text
		PrintMissionText();
		
		// timeleft counter. Let it stay longer on boss battles.
		timeleft = 8;
		if (bossBattle == 1) CreateTimer(GetSpeedMultiplier(3.0), CountDown_Timer);
		else CreateTimer(GetSpeedMultiplier(1.0), CountDown_Timer);
		
		// get the lasting time from the cfg
		microgametimer = CreateTimer(GetSpeedMultiplier(GetMinigameConfFloat(minigame, "duration")), EndGame);
		
		// debug
		if (GetConVarBool(ww_log)) LogMessage("Microgame started post");
	}
	return Plugin_Stop;
}
public Action mg_soundplay(Handle timer)
{
	char sound[512];
	Format(sound, sizeof(sound), "gamesound/csgoware/minigame_%d.mp3", iMinigame);
	if (StrEqual(minigame, "Ghostbusters") && GetRandomInt(1,3) == 1) Format(sound, sizeof(sound), "gamesound/csgoware/minigame_%d_alt.mp3", iMinigame);
	//if (StrEqual(minigame, "BossTarget")) Format(sound, sizeof(sound), "gamesound/csgoware/minigame_%d.wav", iMinigame);
	if (GetConVarBool(ww_music)) EmitSoundToClientAny(1, sound, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL,GetSoundMultiplier());
	else {
		for(int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i)){
				EmitSoundToClientAny(i, sound, _, _, _, _, g_fvol[i],GetSoundMultiplier());
			}
		}
	}
	PrintMissionText();

}
public Action mg_soundplaystart(Handle timer)
{
	float MUSIC_INFO_LEN = MUSIC_START_LEN;
	char MUSIC_INFO[PLATFORM_MAX_PATH];
	Format(MUSIC_INFO, sizeof(MUSIC_INFO), MUSIC_START);
	if (g_Gamemode == GAMEMODE_WIPEOUT) {
		MUSIC_INFO_LEN = MUSIC2_START_LEN;
		Format(MUSIC_INFO, sizeof(MUSIC_INFO), MUSIC2_START);
	}
	if (g_Gamemode == GAMEMODE_WIPEOUT) {
		// Get two people to fight it off
		int personA = GetRandomWipeoutPlayer();
		if (IsValidClient(personA)) g_Participating[personA] = true;
		int personB = GetRandomWipeoutPlayer();
		if (IsValidClient(personB)) g_Participating[personB] = true;
			
		int personC = -1;
		if (GetLeftWipeoutPlayers() > 4) personC = GetRandomWipeoutPlayer();
		if (IsValidClient(personC)) g_Participating[personC] = true;
			
		if (IsValidClient(personA) == false || IsValidClient(personB) == false) {
			status = 4;
			bossBattle = 2;
			CreateTimer(GetSpeedMultiplier(MUSIC_INFO_LEN), Victory_timer);
			return;
		}
		char strMessage[512];
		Format(strMessage, sizeof(strMessage), "%N\n%N", personA, personB);
			
		if (IsValidClient(personC)) Format(strMessage, sizeof(strMessage), "%s\n%N", strMessage, personC);
		PrintCenterTextAll(strMessage);
	}
	else {
		for(int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i) && GetClientTeam(i) >= 2 && g_Spawned[i] == true) g_Participating[i] = true;
		}
	}
		
	if (GetConVarBool(ww_music)) EmitSoundToClientAny(1, MUSIC_INFO, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL,GetSoundMultiplier());
	else {
		for(int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i)){
				EmitSoundToClientAny(i, MUSIC_INFO, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, g_fvol[i], GetSoundMultiplier());
			}	
		}
	}

}
public Action mg_soundplayend(Handle timer)
{
	float MUSIC_INFO_LEN = MUSIC_END_LEN;
	char MUSIC_INFO_WIN[PLATFORM_MAX_PATH];
	char MUSIC_INFO_FAIL[PLATFORM_MAX_PATH];
	Format(MUSIC_INFO_WIN, sizeof(MUSIC_INFO_WIN), MUSIC_WIN);
	Format(MUSIC_INFO_FAIL, sizeof(MUSIC_INFO_FAIL), MUSIC_FAIL);
	if (g_Gamemode == GAMEMODE_WIPEOUT) {
		MUSIC_INFO_LEN = MUSIC2_END_LEN;
		Format(MUSIC_INFO_WIN, sizeof(MUSIC_INFO_WIN), MUSIC2_WIN);
		Format(MUSIC_INFO_FAIL, sizeof(MUSIC_INFO_FAIL), MUSIC2_FAIL);
	}
	for(int i = 1; i <= MaxClients; i++) {
		if (IsValidClient(i) && !IsFakeClient(i) && IsClientParticipating(i)) {
			if (g_Complete[i]) {
				SetOverlay(i,"csgoware_minigame_win_2");
				//CreateTimer(0.3, WinTimer, i);
			}
			if (g_Complete[i] == false) {
				SetOverlay(i,"csgoware_minigame_fail_2");
			}
		}
	}		
	UpdateHud(GetSpeedMultiplier(MUSIC_INFO_LEN));
	char sound[512];
	for(int i = 1; i <= MaxClients; i++) {
		if (IsValidClient(i)) {
			if (IsClientParticipating(i)) {
				// heal everyone
				//TF2_RegeneratePlayer(i);
					
				// Kill their weapons
				DisableClientWeapons(i);
					
				// if client won
				if (g_Complete[i]) {
					Format(sound, sizeof(sound), MUSIC_INFO_WIN);
				}
					
				// if client lost
				if (g_Complete[i] == false) {
					Format(sound, sizeof(sound), MUSIC_INFO_FAIL);
				}
			}
			else {
				Format(sound, sizeof(sound), MUSIC_INFO_WIN);
			}
			char oldsound[512];				
			Format(oldsound, sizeof(oldsound), "gamesound/csgoware/minigame_%d.mp3", iMinigame);
			if (GetMinigameConfNum(minigame, "dynamic", 0)){
				StopSound(i, SND_CHANNEL_SPECIFIC, oldsound);
			}
			if(IsValidClient(i)){
				EmitSoundToClientAny(i, sound, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, g_fvol[i],GetSoundMultiplier());
			}
		}
	}
	return Plugin_Stop;
}
public Action timer_playlate(Handle timer, Handle pack) {

	char str[256];
	int client;
	 
	/* Set to the beginning and unpack it */
	ResetPack(pack);
	client = ReadPackCell(pack);
	ReadPackString(pack, str, sizeof(str));
	PrecacheSound(str, true);
	if(IsValidClient(client)){
		EmitSoundToClientAny(client, str, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, g_fvol[client],GetSoundMultiplier());
	}
	LateTimers[client] = INVALID_HANDLE;
}
int PrintMissionText()
{
	if (GetConVarBool(ww_log))
	{
		LogMessage("Printing mission text");
	}
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i))
		{
			if (g_Gamemode == GAMEMODE_WIPEOUT){
				if(IsValidClient(i)){
					if(g_wipeout_start){
						SetOverlay(i,"");
						//PrintToChatAll("debug wipeout overlay disabled");
						g_wipeout_start = false;
					}
				}
			}
			char missionmessage[256];
			char buffer[128];
			Format(missionmessage, sizeof(missionmessage), "INSTRUCTION_%i_%i", iMinigame, g_Mission[i]+1);
			PrintCenterText(i,"<font color='#15fb00' size='20'>%T</font>", missionmessage, i);
			Format(buffer, sizeof(buffer), "%T", missionmessage, LANG_SERVER);
			if(iMinigame <= 9){
				Format(output2, sizeof(output2), "%1d_%s", iMinigame, minigame);
			}
			if(iMinigame >= 10){
				Format(output2, sizeof(output2), "%2d_%s", iMinigame, minigame);
			}
		}
	}
}

public Action CountDown_Timer(Handle hTimer)
{
	if ((status == 2) && (timeleft > 0))
	{
		timeleft = timeleft - 1;
		CreateTimer(GetSpeedMultiplier(0.4), CountDown_Timer);
		if (bossBattle != 1)
		{
			Call_StartForward(g_OnTimerMinigame);
			Call_PushCell(timeleft);
			Call_Finish();
		}
		if (timeleft == 2)
		{
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i) && (!(IsFakeClient(i))) && g_ModifiedOverlay[i] == false)
				{
					SetOverlay(i, "");
				}
			}
		}
	}
}

public Action EndGame(Handle hTimer) {
	microgametimer = INVALID_HANDLE;
	if (status == 2) {
		if (GetConVarBool(ww_log)) LogMessage("Microgame %s, (id:%d) ended!", minigame, iMinigame);
		Call_StartForward(g_OnAlmostEnd);
		Call_Finish();
		
		status = 0;
		
		float MUSIC_INFO_LEN = MUSIC_END_LEN;
		char MUSIC_INFO_WIN[PLATFORM_MAX_PATH];
		char MUSIC_INFO_FAIL[PLATFORM_MAX_PATH];
		Format(MUSIC_INFO_WIN, sizeof(MUSIC_INFO_WIN), MUSIC_WIN);
		Format(MUSIC_INFO_FAIL, sizeof(MUSIC_INFO_FAIL), MUSIC_FAIL);
		if (g_Gamemode == GAMEMODE_WIPEOUT) {
			MUSIC_INFO_LEN = MUSIC2_END_LEN;
			Format(MUSIC_INFO_WIN, sizeof(MUSIC_INFO_WIN), MUSIC2_WIN);
			Format(MUSIC_INFO_FAIL, sizeof(MUSIC_INFO_FAIL), MUSIC2_FAIL);
		}
		
		if (SpecialRound == 6) g_attack = true;
		else g_attack = false;
		
		Call_StartForward(g_OnEndMinigame);
		Call_Finish();
		
		CleanupAllVocalizations();
		
		currentSpeed = GetConVarFloat(ww_speed);
		SetCommandFlags("host_timescale", GetCommandFlags("host_timescale") & (~FCVAR_CHEAT));
		SetCommandFlags("phys_timescale", GetCommandFlags("phys_timescale") & (~FCVAR_CHEAT));
		ServerCommand("host_timescale %f", GetHostMultiplier(1.0));
		ServerCommand("sm_cvar phys_timescale %f", GetHostMultiplier(1.0));

		char sound[512];
		for(int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i)) {
				if (IsClientParticipating(i)) {
					DisableClientWeapons(i);
						
					// if client won
					if (g_Complete[i]) {
						Format(sound, sizeof(sound), MUSIC_INFO_WIN);
					}
						
					// if client lost
					if (g_Complete[i] == false) {
						Format(sound, sizeof(sound), MUSIC_INFO_FAIL);
					}
				}
				else {
					Format(sound, sizeof(sound), MUSIC_INFO_WIN);
				}
				char oldsound[512];				
				Format(oldsound, sizeof(oldsound), "gamesound/csgoware/minigame_%d.mp3", iMinigame);
				if (GetMinigameConfNum(minigame, "dynamic", 0)){
					StopSound(i, SND_CHANNEL_SPECIFIC, oldsound);
				}
				if(IsValidClient(i)){
					DataPack pack;
					LateTimers[i] = CreateDataTimer(0.2, timer_playlate, pack);
					pack.WriteCell(i);
					pack.WriteString(sound);
				}
			}
		}

		// Clear all functions from forwards
		RemoveAllFromForward(g_justEntered, INVALID_HANDLE);
		RemoveAllFromForward(g_OnAlmostEnd, INVALID_HANDLE);
		RemoveAllFromForward(g_OnTimerMinigame, INVALID_HANDLE);
		RemoveAllFromForward(g_OnEndMinigame, INVALID_HANDLE);
		RemoveAllFromForward(g_OnGameFrame_Minigames, INVALID_HANDLE);
		RemoveAllFromForward(g_PlayerDeath, INVALID_HANDLE);
		for(int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i) && !IsFakeClient(i) && IsClientParticipating(i)) {
				if (g_Complete[i]) {
					SetOverlay(i,"csgoware_minigame_win_2");
					//CreateTimer(0.3, WinTimer, i);
				}
				if (g_Complete[i] == false) {
					SetOverlay(i,"csgoware_minigame_fail_2");
				}
			}
		}		
		// RESPAWN START
		if (GetMinigameConfNum(minigame, "endrespawn", 0) > 0) RespawnAll();
		else RespawnAll();
		//CreateTimer(0.4, mg_soundplayend);
		if (g_Gamemode == GAMEMODE_WIPEOUT) {
			for(int i2 = 1; i2 <= MaxClients; i2++) {
				if (IsValidClient(i2) && IsClientParticipating(i2)) {
					SetWipeoutPosition(i2, true);
				}
			}
		}
		
		if (SpecialRound == 4) NoCollision(true);
		else NoCollision(false);
		
		if (SpecialRound == 7) {
			for(int i = 1; i <= MaxClients; i++) {				
				if (IsValidClient(i) && !IsFakeClient(i)){
					g_bThirdPersonEnabled[i] = true;
				}				
			}
		}
		if (g_Gamemode == GAMEMODE_WIPEOUT) {
			NoCollision(true);
		}
		UpdateHud(GetSpeedMultiplier(MUSIC_INFO_LEN));

		
		bool bHandlePoints = true;
		if (g_Gamemode == GAMEMODE_WIPEOUT) {
			bool bSomeoneWon = false;
			for(int i = 1; i <= MaxClients; i++) {
				if (IsValidClient(i) && IsClientParticipating(i) && g_Complete[i] == true) bSomeoneWon = true;
			}
			if (bSomeoneWon == false && bossBattle == 1 && GetLeftWipeoutPlayers() == 2) {
				bHandlePoints = false;
				CPrintToChatAll("{red}DRAW{default}... playing new boss!");
			}
		}
		if (bHandlePoints) HandOutPoints();
		
		// RESPAWN END
		
		bool speedup = false;
		g_minigamestotal += 1;
		
		if (bossBattle == 1) bossBattle = 2;
		
		if (g_Gamemode == GAMEMODE_WIPEOUT) {
			if ((GetAverageScoreFloat() <= 2.80) && (bossBattle == 0) && currentSpeed <= 1.0) speedup = true;
			if ((GetAverageScoreFloat() <= 2.50) && (bossBattle == 0) && currentSpeed <= 1.0) speedup = true;
			if ((GetAverageScoreFloat() <= 2.20) && (bossBattle == 0) && currentSpeed <= 1.0) speedup = true;
			if ((GetAverageScoreFloat() <= 1.80) && (bossBattle == 0) && currentSpeed <= 1.0) speedup = true;
			if ((GetAverageScoreFloat() <= 1.40) && (bossBattle == 0) && currentSpeed <= 1.0) speedup = true;
			if ((GetAverageScoreFloat() <= 1.0) && (bossBattle == 0) && currentSpeed <= 1.0) speedup = true;
			if ((GetLeftWipeoutPlayers() == 2) && (bossBattle != 1)) {
				speedup = true;
				bossBattle = 1;
			}	
		}
		else {
			if ((g_minigamestotal == 4) && (bossBattle == 0)) speedup = true;
			if ((g_minigamestotal == 8) && (bossBattle == 0)) speedup = true;
			if ((g_minigamestotal == 12) && (bossBattle == 0)) speedup = true;
			if ((g_minigamestotal == 16) && (bossBattle == 0)) speedup = true;
			if ((g_minigamestotal == 19) && (bossBattle == 0)) {
				speedup = true;
				bossBattle = 1;
			}
			if ((g_minigamestotal >= 19) && bossBattle == 2 && SpecialRound == 3 && Special_TwoBosses == false) {
				speedup = true;
				bossBattle = 1;
				Special_TwoBosses = true;
			}
		}
		if (g_Gamemode == GAMEMODE_WIPEOUT && GetLeftWipeoutPlayers() <= 1) {
			status = 4;
			CreateTimer(GetSpeedMultiplier(MUSIC_INFO_LEN), Victory_timer);
		}
		if (speedup == false) {
			status = 10;
			CreateTimer(GetSpeedMultiplier(MUSIC_INFO_LEN), StartMinigame_timer2);
			CreateAllSprites();
		}
		if (speedup == true) {
			status = 3;
			CreateTimer(GetSpeedMultiplier(MUSIC_INFO_LEN), Speedup_timer);
		}
		if (bossBattle == 2 && speedup == false) {
			status = 4;
			CreateTimer(GetSpeedMultiplier(MUSIC_INFO_LEN), Victory_timer);
		}

	}
	return Plugin_Stop;
}

public Action Speedup_timer(Handle hTimer) {
	if (status == 3) {
		DrawScoresheet();
		RemoveAllParticipants();
		if (bossBattle == 1) {
			if (GetConVarBool(ww_log)) LogMessage("GETTING READY TO START SOME BOSS");
			float MUSIC_INFO_LEN = MUSIC_BOSS_LEN;
			char MUSIC_INFO[PLATFORM_MAX_PATH];
			Format(MUSIC_INFO, sizeof(MUSIC_INFO), MUSIC_BOSS);
			if (g_Gamemode == GAMEMODE_WIPEOUT) {
				MUSIC_INFO_LEN = MUSIC2_BOSS_LEN;
				Format(MUSIC_INFO, sizeof(MUSIC_INFO), MUSIC2_BOSS);
			}
			
			if (GetConVarBool(ww_log)) LogMessage("Boss part 2");
		
			// Set the Speed. If special round, we want it to be a tad faster ;)
			if (SpecialRound == 1) SetConVarFloat(ww_speed, 2.0);
			else SetConVarFloat(ww_speed, 1.0);
			
			if (GetConVarBool(ww_log)) LogMessage("Boss part 3");
			currentSpeed = GetConVarFloat(ww_speed);
			SetCommandFlags("host_timescale", GetCommandFlags("host_timescale") & (~FCVAR_CHEAT));
			SetCommandFlags("phys_timescale", GetCommandFlags("phys_timescale") & (~FCVAR_CHEAT));
			ServerCommand("host_timescale %f", GetHostMultiplier(1.0));
			ServerCommand("sm_cvar phys_timescale %f", GetHostMultiplier(1.0));
			if (GetConVarBool(ww_log)) LogMessage("Boss part 4");
			
			CreateTimer(GetSpeedMultiplier(MUSIC_INFO_LEN), StartMinigame_timer2);
			
			if (GetConVarBool(ww_log)) LogMessage("Boss part 5");
			
			if (GetConVarBool(ww_music)) EmitSoundToClientAny(1, MUSIC_INFO, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL,GetSoundMultiplier());
			else {
				for(int i = 1; i <= MaxClients; i++) {
					if (IsValidClient(i)){
						EmitSoundToClientAny(i, MUSIC_INFO, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, g_fvol[i], GetSoundMultiplier());
					}	
				}
			}
			for(int i = 1; i <= MaxClients; i++) {
				if (IsValidClient(i) && (!(IsFakeClient(i)))) {
					SetOverlay(i,"csgoware_minigame_boss_2");
				}
			}	  

			if (GetConVarBool(ww_log)) LogMessage("Boss part 6");
			
			//UpdateHud(GetSpeedMultiplier(MUSIC_INFO_LEN));
		}
		
		if (GetConVarBool(ww_log)) LogMessage("Boss part 7");
		
		if (bossBattle != 1) {
			float MUSIC_INFO_LEN = MUSIC_SPEEDUP_LEN;
			char MUSIC_INFO[PLATFORM_MAX_PATH];
			Format(MUSIC_INFO, sizeof(MUSIC_INFO), MUSIC_SPEEDUP);
			if (g_Gamemode == GAMEMODE_WIPEOUT) {
				MUSIC_INFO_LEN = MUSIC2_SPEEDUP_LEN;
				Format(MUSIC_INFO, sizeof(MUSIC_INFO), MUSIC2_SPEEDUP);
			}
		
			if (GetConVarBool(ww_music)) EmitSoundToClientAny(1, MUSIC_INFO, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL,GetSoundMultiplier());
			else{
				for(int i = 1; i <= MaxClients; i++) {
					if (IsValidClient(i)){
						EmitSoundToClientAny(i, MUSIC_INFO, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, g_fvol[i], GetSoundMultiplier());
					}	
				}
			}
			for(int i = 1; i <= MaxClients; i++) {
				if (IsValidClient(i) && (!(IsFakeClient(i)))) {
					SetOverlay(i,"csgoware_minigame_speed_2");
				}
			}
			//UpdateHud(GetSpeedMultiplier(MUSIC_INFO_LEN));
			SetConVarFloat(ww_speed, GetConVarFloat(ww_speed) + 0.5);
			CreateTimer(GetSpeedMultiplier(MUSIC_INFO_LEN), StartMinigame_timer2);
		}
		
		if (GetConVarBool(ww_log)) LogMessage("Boss part 8");
		
		status = 10;
		
		if (GetConVarBool(ww_log)) LogMessage("Post boss");
	}
}

public Action Victory_timer(Handle hTimer)
{
	if ((status == 4) && (bossBattle > 0))
	{
		bossBattle = 0;
		SetConVarFloat(ww_speed, 1.0);
		currentSpeed = GetConVarFloat(ww_speed);
	   
		CreateTimer(GetSpeedMultiplier(13.17), Restartall_timer);
		status = 5;
	   
		float MUSIC_INFO_LEN = MUSIC_GAMEOVER_LEN;
		char MUSIC_INFO[PLATFORM_MAX_PATH];
		Format(MUSIC_INFO, sizeof(MUSIC_INFO), MUSIC_GAMEOVER);
		if (g_Gamemode == GAMEMODE_WIPEOUT)
		{
			MUSIC_INFO_LEN = MUSIC2_GAMEOVER_LEN;
			Format(MUSIC_INFO, sizeof(MUSIC_INFO), MUSIC2_GAMEOVER);
		}
	   
		if (GetConVarBool(ww_music))
		{
			EmitSoundToClientAny(1, MUSIC_INFO, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL,GetSoundMultiplier());
		}
		else
		{
			for(int i = 1; i <= MaxClients; i++) {
				if (IsValidClient(i)){
					EmitSoundToClientAny(i, MUSIC_INFO, SOUND_FROM_PLAYER, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, g_fvol[i], GetSoundMultiplier());
				}	
			}
		}
	   
		ResetWinners();
	   
		int targetscore = GetHighestScore();
		if (SpecialRound == 5)
		{
			targetscore = GetLowestScore();
		}
		int winnernumber = 0;
		Handle ArrayWinners = CreateArray();
		char winnerstring_names[512];
		char pointsname[512];
		//char buffer[128];
		Format(pointsname, sizeof(pointsname), "%t", "points");
		if (g_Gamemode == GAMEMODE_WIPEOUT)
		{
			Format(pointsname, sizeof(pointsname), "%t", "lives");
		}
	   
		bool bAccepted = false;
		for (int i = 1; i <= MaxClients; i++)
		{
			SetOverlay(i, "");
			if (IsValidClient(i) && (GetClientTeam(i) == 2 || GetClientTeam(i) == 3))
			{
				bAccepted = false;
				if (g_Gamemode == GAMEMODE_WIPEOUT)
				{
					if (g_Points[i] > 0)
					{
						bAccepted = true;
					}
				}
				else
				{
					if (SpecialRound != 5 && g_Points[i] >= targetscore)
					{
						bAccepted = true;
					}
					if (SpecialRound == 5 && g_Points[i] <= targetscore)
					{
						bAccepted = true;
					}
				}
				if (bAccepted)
				{
					g_Winner[i] = 1;
					CreateSprite(i);
					//RespawnClient(i, false, false);
					RespawnClientEnd(i);
					SetWeaponState(i, true);
					winnernumber += 1;
					for (int i3 = 1; i3 <= MaxClients; i3++)
					{
						if (IsValidClient(i3) && g_Winner[i3]){
							if (g_Gamemode == GAMEMODE_WIPEOUT)
							{
								CS_RespawnPlayer(i3);
							}
						}
						if (IsValidClient(i3) && !g_Winner[i3]){
							if (g_Gamemode == GAMEMODE_WIPEOUT)
							{
								CS_RespawnPlayer(i3);
							}
						}
					}
					PushArrayCell(ArrayWinners, i);
				}
			}
		}
		for(int i = 0; i < GetArraySize(ArrayWinners); i++) {
			int client = GetArrayCell(ArrayWinners, i);
			if (winnernumber > 1) {
				if (i >= (GetArraySize(ArrayWinners)-1)){
					Format(winnerstring_names, sizeof(winnerstring_names), "%s {olive}%N{green}", winnerstring_names, client);
				}
				else Format(winnerstring_names, sizeof(winnerstring_names), "%s, {olive}%N{green}", winnerstring_names, client);
			}
			else Format(winnerstring_names, sizeof(winnerstring_names), "{olive}%N{green}", client);
			AddToClientWinPoints(client);
		}
		if (winnernumber > 1) ReplaceStringEx(winnerstring_names, sizeof(winnerstring_names), ", ", "");
		
		if (winnernumber == 1) CPrintToChatAll("%t %s (%i %s)!", "NOTIFY_WINNER", winnerstring_names, targetscore, pointsname);
		else  CPrintToChatAll("%t %s (%i %s)!", "NOTIFY_WINNERS", winnerstring_names, targetscore, pointsname);
		
	   
		CloseHandle(ArrayWinners);
		//IsEnd = true;
		//int TimeNeeded = 13;
		//ActiveFireworks();
		//CreateTimer(TimeNeeded*1.0, TimerStopFireworks);
		
		if (SpecialRound > 0) {
			CPrintToChatAll("The {lightgreen}Special Round{default} is over!");
			ResetSpecialRoundEffect();
			SpecialRound = 0;
			//ShowGameText("Special Round is over!");
			for(int i; i <=MaxClients; i++) {
				if(IsValidClient(i)){
					//PrintHintText(i, "Special Round is over!");
					PrintCenterText(i,"<font color='#15fb00' size='20'>Special Round is over!</font>");
				}
			}
		}
		UpdateHud(GetSpeedMultiplier(MUSIC_INFO_LEN));	  
	}
	return Plugin_Stop;
}

public Action Restartall_timer(Handle hTimer)
{
	if (status == 5)
	{
		bossBattle = 0;
		
		// Set the game speed
		if (SpecialRound == 1)
		{ 
			SetConVarFloat(ww_speed, 2.5);

			if (bossBattle == 1)
			{
				SetConVarFloat(ww_speed, 1.0);
			}
		}
		else
		{
			SetConVarFloat(ww_speed, 1.0);
		}
		
		if (SpecialRound > 0)
		{
			AddSpecialRoundEffect();
		}
		
		currentSpeed = GetConVarFloat(ww_speed);
		ResetScores();
		SetStateAll(false);
		ResetWinners();
		g_minigamestotal = 0;
		
		
		for (int i = 1; i <= MaxClients; i++)
		{
			if (IsValidClient(i) && IsPlayerAlive(i)) DisableClientWeapons(i);
		}
		
		// Roll special round
		if ((GetRandomInt(0,10) == 5 || GetConVarBool(ww_special)) && SpecialRound == 0)
		{
			status = 6;
			StartSpecialRound();
		}
		else
		{
			status = 0;
			SetGameMode();
			ResetScores();
			StartMinigame();
		}
	}
	return Plugin_Stop;
}

int var_SpecialRoundRoll = 0;
int var_SpecialRoundCount = 0;

public int StartSpecialRound() {
	if (status == 6) {
		RespawnAll();
		SetConVarBool(ww_special, false);
		if (GetConVarInt(ww_force_special) <= 0) SpecialRound = GetRandomInt(1,SPECIAL_TOTAL);
		else SpecialRound = GetConVarInt(ww_force_special);
	
		if (GetConVarBool(ww_music)) EmitSoundToClientAny(1, MUSIC_SPECIAL);
		else EmitSoundToAllAny(MUSIC_SPECIAL);
		
		status = 5;
		CreateTimer(0.1, SpecialRound_timer);
		
		var_SpecialRoundCount = 130;
		
		CreateTimer(GetSpeedMultiplier(MUSIC_SPECIAL_LEN), Restartall_timer);
		
		for(int i = 1; i <= MaxClients; i++) {
			if (IsValidClient(i) && (!(IsFakeClient(i)))) {
				SetOverlay(i,"");
			}
		}
	}
}

public Action SpecialRound_timer(Handle hTimer) {
	if (status == 5 && var_SpecialRoundCount > 0) {
		CreateTimer(0.0, SpecialRound_timer);
		
		var_SpecialRoundCount -= 1;
		var_SpecialRoundRoll += 1;
		if (var_SpecialRoundRoll > sizeof(var_special_name)+1) var_SpecialRoundRoll = 0;
		char Name[128];
		if (var_SpecialRoundRoll < sizeof(var_special_name)) Format(Name, sizeof(Name), var_special_name[var_SpecialRoundRoll]);
		else {
			char var_funny_names[][] = {"FAT LARD RUN", "MOUSTACHIO", "LOVE STORY", "SIZE MATTERS", "ENGINERD", "IDLE FOR HATS", "TF2 BROS: BRAWL", "HOT SPY ON ICE"};
			Format(Name, sizeof(Name), var_funny_names[GetRandomInt(0, sizeof(var_funny_names)-1)]);
		}
		
		if (var_SpecialRoundCount > 0) {
			char Text[128];
			Format(Text, sizeof(Text), "SPECIAL ROUND: %s?\nSpecial Round adds a new condition to the next round!", Name);
			//ShowGameText(Text, "leaderboard_dominated", 1.0);
			for(int i; i <=MaxClients; i++) {
				if(IsValidClient(i)){
					//PrintHintText(i, "%s", Text);
					PrintCenterText(i,"<font color='#15fb00' size='15'>%s</font>", Text);
				}
			}
		}
		
		if (var_SpecialRoundCount == 0) {
			if (GetConVarBool(ww_music)) EmitSoundToClientAny(1, SOUND_SELECT);
			else EmitSoundToAllAny(SOUND_SELECT);
			GiveSpecialRoundInfo();
		}	 
	}
}

int GiveSpecialRoundInfo() {
	if (SpecialRound > 0) {
		char Text[128];
		Format(Text, sizeof(Text), "SPECIAL ROUND: %s!\n%s", var_special_name[SpecialRound-1], var_special_desc[SpecialRound-1]);
		//ShowGameText(Text, "leaderboard_dominated");
		for(int i; i <=MaxClients; i++) {
			if(IsValidClient(i)){
				//PrintHintText(i, "%s", Text);
				PrintCenterText(i,"<font color='#15fb00' size='15'>%s</font>", Text);
			}
		}
	}
}

public Action Command_event(int client, int args)
{
	status = 6;
	StartSpecialRound();
	SetConVarBool(ww_enable, true);
	return Plugin_Handled;
}

int SetStateAll(bool value)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		g_Complete[i] = value;
	}
}

int SetMissionAll(int value)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		g_Mission[i] = value;
	}
}

int SetClientSlot(int client, int slot)
{
	if (GetConVarBool(ww_log))
	{
		LogMessage("Setting client slot");
	}
	int weapon = GetPlayerWeaponSlot(client, slot);
	SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", weapon);
}

int RespawnAll()
{
	if (GetConVarBool(ww_log))
	{
		LogMessage("Respawning everyone");
	}
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && (GetClientTeam(i) == 2 || GetClientTeam(i) == 3))
		{
			RespawnClientEnd(i);
		}
	}
}
int RespawnClientEnd(int client){
	if (IsValidClient(client) && IsValidTeam(client) && (g_Spawned[client] == true)) {
		if (g_Gamemode == GAMEMODE_WIPEOUT && g_Points[client] <= 0)return;
		if (g_Gamemode == GAMEMODE_WIPEOUT && g_Participating[client]){
			CS_RespawnPlayer(client);
		}
		if (g_Gamemode == GAMEMODE_WIPEOUT && IsValidClient(client) && IsValidTeam(client) && !IsPlayerAlive(client) && g_Points[client] >= 1){
			CS_RespawnPlayer(client);
		}
		if (g_Gamemode == GAMEMODE_NORMAL){
			CS_RespawnPlayer(client);
		}
		if (SpecialRound == 7) {				
			if (!IsFakeClient(client)){	 
				g_bThirdPersonEnabled[client] = true;			
			}
		}
	}
}
int RespawnClientGeneric(int client){
	if (IsValidClient(client) && IsValidTeam(client) && (g_Spawned[client] == true)) {
		if (!IsPlayerAlive(client)){
			if (g_Gamemode == GAMEMODE_WIPEOUT && g_Points[client] <= 0)return;
			CS_RespawnPlayer(client);
		}
		if (SpecialRound == 7) {				
			if (!IsFakeClient(client)){	 
				g_bThirdPersonEnabled[client] = true;			
			}
		}
	}
}
int RespawnClient(any i, bool force = false, bool savepos = true) {
	float pos[3];
	float vel[3];
	float ang[3];
	int alive = false;
	if (IsValidClient(i) && IsValidTeam(i) && (g_Spawned[i] == true)) {
		bool force2 = false;
		if (!IsPlayerAlive(i)) force2 = true;
		if (force && IsClientParticipating(i)) force2 = true;
		if (g_Gamemode == GAMEMODE_WIPEOUT && g_Points[i] <= 0) force2 = false;
		if (force2) {
			alive = false;
			if (savepos) {
				GetClientAbsOrigin(i, pos);
				GetClientEyeAngles(i, ang);
				GetEntPropVector(i, Prop_Data, "m_vecVelocity", vel);
				if (IsPlayerAlive(i)) alive = true;			
			}
			CS_RespawnPlayer(i);
			if ((savepos) && (alive)) TeleportEntity(i, pos, ang, vel);			
		}
		if (SpecialRound == 7) {				
			if (IsValidClient(i) && !IsFakeClient(i)){	 
				g_bThirdPersonEnabled[i] = true;			
			}
		}		
	}	
}

int DrawScoresheet()
{
	Panel top10 = CreatePanel(GetMenuStyleHandle(MenuStyle_Radio))
	char srank[127];
	Format(srank, sizeof(srank), "%t", "ROUND_RANKING")
	DrawPanelText(top10, srank);
	int[] clients = new int[MaxClients+1];

	for (int i; i <=MaxClients; i++)
	{
		clients[i] = i;
	}
	SortCustom1D(clients, MaxClients, ScoreGreaterThan);
	char cName[256];
	char Sheet[512];
	char text[127];
	int count = -0;
	for (int i=MaxClients; i>-0; i--)
	{
		if (count >= 10)
		{
			break;
		}
		if (IsValidClient(clients[i]) && !IsClientObserver(clients[i]))
		{
			GetClientName(clients[i], cName, sizeof(cName));
			Format(Sheet, sizeof(Sheet), "%2d - %s", g_Points[clients[i]], cName);
			Format(text,127,"%s", Sheet);
			DrawPanelText(top10, text);
			count++;
		}
	}
	for(int k; k <=MaxClients; k++) {
		if(IsValidClient(k)){
			SendPanelToClient(top10, k, csgomenu, 5);
		}
		//CloseHandle(top10);
	}
}

int SetStateClient(int client, bool value, bool complete=false) {
	if (IsValidClient(client) && IsClientParticipating(client)) {
		if (complete && g_Complete[client] != value) {
			if (value) {
				//EmitSoundToClientAny(client, SOUND_COMPLETE);
				//EmitSoundCustom(client, SOUND_COMPLETE);
				
				for(int i = 1; i <= MaxClients; i++) {
					if (IsValidClient(i) && !IsFakeClient(i)) {
						//EmitSoundToClientAny(i, SOUND_COMPLETE_YOU, client);
						if (IsClientParticipating(i) && IsPlayerAlive(i) && g_Gamemode == GAMEMODE_WIPEOUT && i != client) {
							SetStateClient(i, false, true);
							ForcePlayerSuicide(i);
							CPrintToChatEx(i, client, "{green}You were beaten by {teamcolor}%N{green}!", client);
						}
					}
				}
				char text[128];
				Panel panel = CreatePanel(GetMenuStyleHandle(MenuStyle_Radio));
				Format(text,127,"YOU DID IT!");
				DrawPanelText(panel, text);
				SendPanelToClient(panel, client, csgomenu, 2);		 
				CloseHandle(panel);
			}
		}
		g_Complete[client] = value;
	}
}
stock float GetSpeedMultiplier(float count)
{
	float divide = ((currentSpeed-1.0)/10.0)+1.0;
	float speed = count / divide;
	return speed;
}
stock float GetHostMultiplier(float count)
{
	float divide = ((currentSpeed-1.0)/10.0)+1.0;
	float speed = count * divide;
	return speed;
}
int GetSoundMultiplier()
{
	int speed = SNDPITCH_NORMAL + RoundFloat((currentSpeed-1.0)*21.0);
	return speed;
}

int SetOverlay(int i, char overlay[512])
{
	if (IsValidClient(i) && (!(IsFakeClient(i))))
	{
		char language[512];
		char input[512];
		// TRANSLATION
		Format(language, sizeof(language), "");
		
		if (g_Country[i] > 0)
		{
			Format(language, sizeof(language), "/%s",var_lang[g_Country[i]]);
		}
		
		if (StrEqual(overlay, ""))
		{
			Format(input, sizeof(input), "r_screenoverlay \"\"");
		}
		if (!(StrEqual(overlay, "")))
		{
			Format(input, sizeof(input), "r_screenoverlay \"%s%s%s\"", materialpath,language,overlay);
		}
		ClientCommand(i,input);
		g_ModifiedOverlay[i] = true;
	}
}
int UpdateHud(float time) {
	char output[512];
	char add[5];
	char scorename[26];
	Format(scorename, sizeof(scorename), "%t", "POINTS_HUD");
	if (g_Gamemode == GAMEMODE_WIPEOUT && SpecialRound != 7) {
		Format(scorename, sizeof(scorename), "%t", "LIVES_HUD");
	}
	for(int i = 1; i <= MaxClients; i++) {
		if (IsValidClient(i)) {
			Format(add, sizeof(add), "");
			if (g_Gamemode == GAMEMODE_WIPEOUT) {
				if (!g_Complete[i] && IsClientParticipating(i) && bossBattle != 1 && SpecialRound != 7) Format(add, sizeof(add), "-1");
				if (!g_Complete[i] && IsClientParticipating(i) && bossBattle == 1 && SpecialRound != 7) Format(add, sizeof(add), "-5");
			}
			else {
				if (g_Complete[i] && IsClientParticipating(i) && bossBattle != 1 && SpecialRound != 7) Format(add, sizeof(add), "+1");
				if (g_Complete[i] && IsClientParticipating(i) && bossBattle == 1 && SpecialRound != 7) Format(add, sizeof(add), "+5");
			}
			int mtime = RoundToFloor(time);
			Format(output, sizeof(output), "%s %i%s", scorename, g_Points[i], add);
			Panel panel = CreatePanel(GetMenuStyleHandle(MenuStyle_Radio));
			char text[128];
			Format(text,127,"%s", output);
			DrawPanelText(panel, text);		
			SendPanelToClient(panel, i, csgomenu, mtime);		 
			CloseHandle(panel);

		}
	}
}
public int csgomenu(Menu menu, MenuAction action, int param1, int param2)
{
}
public int SortPlayerTimes(elem1[],elem2[],const array[][],Handle hndl)
{
	if(elem1[1] > elem2[1])
	{
		return -1;
	}
	else if(elem1[1] < elem2[1])
	{
		return 1;
	}
	return 0;
}  

int ResetScores()
{
	for(int i = 1; i <= MaxClients; i++)
	{
		if (g_Gamemode == GAMEMODE_WIPEOUT)
		{
			g_Points[i] = 3;
			g_wipeout_start = true;
			//PrintToChatAll("debug wipeout overlay enabled");
		}
		else
		{
			g_Points[i] = 0;
		}
	}
}

int GetHighestScore()
{
	int out = 0;
	
	for(int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && GetClientTeam(i) >= 2 && g_Points[i] > out)
		{
			out = g_Points[i];
		}
	}
	return out;
}

int GetLowestScore()
{
	int out = 99;
	
	for(int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && GetClientTeam(i) >= 2 && g_Points[i] < out)
		{
			out = g_Points[i];
		}
	}
	return out;
}

int GetAverageScore()
{
	int out = 0;
	int total = 0;
	
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && GetClientTeam(i) >= 2 && (g_Points[i] > 0))
		{
			out += g_Points[i];
			total += 1;
		}
	}
	
	if ((total > 0) && (out > 0)) out = out / total;
	
	return out;
}

stock float GetAverageScoreFloat()
{
	int out = 0;
	float out2 = 0.0;
	int total = 0;
	
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && GetClientTeam(i) >= 2 && (g_Points[i] > 0))
		{
			out += g_Points[i];
			total += 1;
		}
	}
	
	if ((total > 0) && (out > 0))
	{
		out2 = float(out) / float(total);
	}
	
	return out2;
}

int ResetWinners()
{
	for (int i = 1; i <= MaxClients; i++)
	{
		g_Winner[i] = 0;
	}
}

public Action Command_points(int client, int args)
{
	CPrintToChatAll("%t\x01: %t", "CSGOWARE_PREFIX_COLOR", "NOTIFY_POINTS", client);
	g_Points[client] += 20;
	g_Points[0] += 20;
	g_Points[1] += 20;
	return Plugin_Handled;
}

public Action Command_list(int client, int args)
{
	PrintToConsole(client, "Listing all registered minigames...");
	char output[128];
	for (int i=0; i<sizeof(g_name); i++)
	{
		if (StrEqual(g_name[i], ""))
		{
			continue;
		}
		if (GetMinigameConfNum(g_name[i], "enable", 1))
		{
			Format(output, sizeof(output), " %2d - %s", GetMinigameConfNum(g_name[i], "id"), g_name[i]);
		}
		else
		{
			Format(output, sizeof(output), " %2d - %s (disabled)", GetMinigameConfNum(g_name[i], "id"), g_name[i]);
		}
		PrintToConsole(client, output);
	}
}

int RemoveNotifyFlag(char name[128])
{
	Handle cv1 = FindConVar(name);
	int flags = GetConVarFlags(cv1);
	flags &= ~FCVAR_REPLICATED;
	flags &= ~FCVAR_NOTIFY;
	SetConVarFlags(cv1, flags);
}

int InitMinigame(int id)
{
	GiveId();
	Call_StartFunction(INVALID_HANDLE, g_initFuncs[id-1]);
	Call_Finish();
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && IsClientParticipating(i))
		{
			Call_StartForward(g_justEntered);
			//DestroySprite(i);
			Call_PushCell(i);
			Call_Finish();
		}
	}
}

public void Player_Death(Event event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));	
	if (GetConVarBool(ww_enable) && (status == 2))
	{
	
		if (g_PlayerDeath != INVALID_HANDLE && IsValidClient(client) && IsClientParticipating(client))
		{
			Call_StartForward(g_PlayerDeath);
			Call_PushCell(client);
			Call_Finish();
		}
		if ((g_Sprites[client]) > 0)
		{
			DestroySprite(client);
		}
	}
}
public int ScoreGreaterThan(int left, int right,  const int[] clientids, Handle data)
{
	if (g_Points[left] <= g_Points[right])
	{
		return -1;
	}
	if (g_Points[left] == g_Points[right])
	{
		return 0;
	}
	return 1;
}

// Some convenience functions for parsing the configuration file more simply.
int GotoGameConf(char[] game)
{
	if (!KvJumpToKey(MinigameConf, game))
	{
		PrintToServer("ERROR: Couldn't find requested iMinigame %s in configuration file!", game);
		KvRewind(MinigameConf);
	}
}

float GetMinigameConfFloat(char[] game, char[] key, float def=4.0)
{
	GotoGameConf(game);
	float value = KvGetFloat(MinigameConf, key, def);
	KvGoBack(MinigameConf);
	return value;
}

int GetMinigameConfNum(char[] game, char[] key, int def=0)
{
	GotoGameConf(game);
	int value = KvGetNum(MinigameConf, key, def);
	KvGoBack(MinigameConf);
	return value;
}

int GetRandomWipeoutPlayer()
{
	Handle roll = CreateArray();
	int out = -1;
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && GetClientTeam(i) >= 2 && IsClientParticipating(i) == false && g_Points[i] > 0)
		{
			PushArrayCell(roll, i);
		}
	}
		
	if (GetArraySize(roll) > 0) out = GetArrayCell(roll, GetRandomInt(0, GetArraySize(roll)-1));
	{
		CloseHandle(roll);
	}
	return out;
}

stock bool IsClientParticipating(int iClient)
{
	if ((g_Participating[iClient] == false) || (GetClientTeam(iClient) == 1))
	{
		return false;
	}
	return true;
}

int SetGameMode()
{
	int iOld = g_Gamemode;
	int iGamemode = GetConVarInt(ww_gamemode);
	if (iGamemode >= 0)
	{
		g_Gamemode = iGamemode;
	}
	else
	{
		g_Gamemode = GAMEMODE_NORMAL;
		int iRoll = GetRandomInt(0, 100);
		if (iRoll <= 5)
		{
			g_Gamemode = GAMEMODE_WIPEOUT;
		}
	}
	
	if (iOld == GAMEMODE_WIPEOUT && g_Gamemode != iOld)
	{
		for (int i = 1; i <= MaxClients; i++)
		{
			if (IsValidClient(i) && IsPlayerAlive(i))
			{
				SetWipeoutPosition(i, false);
				NoCollision(true);
			}
		}
	}
	if (g_Gamemode == GAMEMODE_WIPEOUT && g_Gamemode != iOld)
	{
		for (int i = 1; i <= MaxClients; i++)
		{
			if (IsValidClient(i) && IsPlayerAlive(i))
			{
				SetWipeoutPosition(i, true);
				NoCollision(true);
			}
		}
	}
}
int RemoveAllParticipants()
{
	for (int i = 1; i <= MaxClients; i++)
	{
		g_Participating[i] = false;
	}
}

int GetLeftWipeoutPlayers()
{
	int out = 0;
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && GetClientTeam(i) >= 2 && g_Points[i] > 0)
		{
			out ++;
		}
	}
	return out;
}

int SetWipeoutPosition(int iClient, bool bState = false)
{
	float fPos[3];
	float ang[3];
	GetClientAbsOrigin(iClient, fPos);
	if (bState)
	{
		if(IsValidClient(iClient) && GetClientTeam(iClient) == 2){
			//fPos[2] = GAMEMODE_WIPEOUT_HEIGHT;
			fPos[0] = 63.183632;
			fPos[1] = 467.604126;
			fPos[2] = 666.093811;
			ang[0] = 0.0;
			ang[1] = -90.0;
			ang[2] = 0.0;
			NoCollision(true);
		}
		if(IsValidClient(iClient) && GetClientTeam(iClient) == 3){
			//fPos[2] = GAMEMODE_WIPEOUT_HEIGHT;
			fPos[0] = 45.728073;
			fPos[1] = -282.497223;
			fPos[2] = 666.093811;
			ang[0] = 0.0;
			ang[1] = 90.0;
			ang[2] = 0.0;
			NoCollision(true);
		}
		TeleportEntity(iClient, fPos, ang, NULL_VECTOR);
	}
	else
	{
		//fPos[2] = -70.0;
		int total = 3;
		int posa = 360 / total * (g_Id[iClient]-1);
		
		float bpos[3];
		bpos[0] = -10.875262  + (Cosine(DegToRad(float(posa)))*220.0);
		bpos[1] = 20.072290 - (Sine(DegToRad(float(posa)))*220.0);
		bpos[2] = -680.080322;

		float angb[3];
		angb[0] = 0.0;
		angb[1] = float(180-posa);
		angb[2] = 0.0;
		TeleportEntity(iClient, bpos, angb, NULL_VECTOR);
		NoCollision(true);
	}
}

public Action Timer_HandleWOLives(Handle hTimer, any iClient)
{
	HandleWipeoutLives(iClient);
}

int HandleWipeoutLives(int iClient, bool bMessage = false)
{
	if (g_Gamemode == GAMEMODE_WIPEOUT && IsValidClient(iClient) && IsPlayerAlive(iClient) && g_Points[iClient] <= 0)
	{
		if (bMessage)
		{
			if (g_Points[iClient] == 0)
			{
				CPrintToChatAllEx(iClient, "%t\x01: %t", "CSGOWARE_PREFIX_COLOR", "NOTIFY_WIPED_OUT", iClient);
			}
			if(g_Points[iClient] < 0)
			{
				CPrintToChat(iClient, "%t\x01: %t", "CSGOWARE_PREFIX_COLOR", "NOTIFY_WIPED_WAIT");
			}
		}
		ForcePlayerSuicide(iClient);
		CreateTimer(0.2, Timer_HandleWOLives, iClient);
	}
}

bool IsValidTeam(int iClient)
{
	int iTeam = GetClientTeam(iClient);
	if (iTeam == 2 || iTeam == 3)
	{
		return true;
	}
	return false;

}
stock void PrecacheModelEx(char[] strFileName, bool bPreload=false, bool bAddToDownloadTable=false)
{
	PrecacheModel(strFileName, bPreload);
	if (bAddToDownloadTable)
	{
		char strDepFileName[PLATFORM_MAX_PATH];
		Format(strDepFileName, sizeof(strDepFileName), "%s.res", strFileName);
		
		if (FileExists(strDepFileName))
		{
			// Open stream, if possible
			Handle hStream = OpenFile(strDepFileName, "r");
			if (hStream == INVALID_HANDLE)
			{
				LogMessage("Error, can't read file containing model dependencies.");
				return;
			}
			
			while(!IsEndOfFile(hStream))
			{
				char strBuffer[PLATFORM_MAX_PATH];
				ReadFileLine(hStream, strBuffer, sizeof(strBuffer));
				CleanString(strBuffer);
				
				// If file exists...
				if (FileExists(strBuffer, true))
				{
					// Precache depending on type, and add to download table
					if (StrContains(strBuffer, ".vmt", false) != -1)	  PrecacheDecal(strBuffer, true);
					else if (StrContains(strBuffer, ".mdl", false) != -1) PrecacheModel(strBuffer, true);
					else if (StrContains(strBuffer, ".pcf", false) != -1) PrecacheGeneric(strBuffer, true);
					AddFileToDownloadsTable(strBuffer);
				}
			}
			
			// Close file
			CloseHandle(hStream);
		}
	}
}
public void OnMapEnd()
{
	ServerCommand("ww_gamedescription 0.0");
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) && (!(IsFakeClient(i))))
		{
			SetOverlay(i,"");
		}
	}
}
stock int AddToClientWinPoints(int client)
{
	if (!IsValidClient(client))
	{
		return;
	}
	int points = 0;
	char oldpts[64];
	if (!IsFakeClient(client) && AreClientCookiesCached(client))
	{
		GetClientCookie(client, clientCookie, oldpts, sizeof(oldpts));
		points = StringToInt(oldpts);
		points += 1;
		IntToString(points, oldpts, sizeof(oldpts));
		SetClientCookie(client, clientCookie, oldpts);
	}
	if (points <= 1)
	{	
		char buffer[128];
		CPrintToChatAllEx(client, "%T\x01 %T", "CSGOWARE_RANK_PREFIX_COLOR", client, "NOTIFY_VICTORY_FIRST", client, client);
		Format(buffer, sizeof(buffer), "%T\x01 %T ", "CSGOWARE_RANK_PREFIX_COLOR", LANG_SERVER, "NOTIFY_VICTORY_FIRST", LANG_SERVER, client);
	}
	else
	{
		char buffer[128];
		CPrintToChatAllEx(client, "%T\x01 %T ", "CSGOWARE_RANK_PREFIX_COLOR", client, "NOTIFY_VICTORY", client, client, points);
		Format(buffer, sizeof(buffer), "%T\x01 %T ", "CSGOWARE_RANK_PREFIX_COLOR", LANG_SERVER, "NOTIFY_VICTORY", LANG_SERVER, client, points);
	}
	LogMessage("%N victory, wins: %d.", client, points);
}
public Action RemoveWarmup(Handle timer)
{
	if (g_enabled && GetConVarBool(ww_enable)) {
		ServerCommand("mp_restartgame 1");
	}
}


public void OnEntityCreated(int entity, const char[] classname)
{
	//CPrintToChatAll("Entity: %s",classname);
	//CPrintToChatAll("Entity: %i",entity);

	//if (GetConVarBool(ww_log))
	//{
	//LogMessage("Entity Added : %s", classname);
	//}
	if (StrEqual(minigame, "BBall")){
		if ((status == 2) && (StrEqual(classname, "hegrenade_projectile")))
		{
			SDKHook(entity, SDKHook_StartTouch, Hook_StartTouch_He);		
		}
	}
	if (StrEqual(minigame, "CatchBarrels"))
	{
		if ((status == 2) && (StrEqual(classname, "prop_physics")))
		{
			SDKHook(entity, SDKHook_StartTouch, OnTouchBarrel);		
		}
	}
}
public int OnSpawnParticlesFire(int entity)
{
	if(IsValidEntity(entity)){
		char sAddOutput[64];
		// Remove the light when the smoke vanished
		Format(sAddOutput, sizeof(sAddOutput), "OnUser1 !self:kill::2.0:1");
		SetVariantString(sAddOutput);

		AcceptEntityInput(entity, "Kill");
		AcceptEntityInput(entity, "sAddOutput");
		AcceptEntityInput(entity, "FireUser1");
	}
}
public Action TE_OnEffectDispatch(const char[] te_name, const Players[], int numClients, float delay)
{
	int iEffectIndex = TE_ReadNum("m_iEffectName");
	char sEffectName[9];
	
	ReadStringTable(g_i_EffectDispatchTable, iEffectIndex, sEffectName, sizeof(sEffectName));
	
	if(StrEqual(sEffectName, "csblood"))
		return Plugin_Handled;

	return Plugin_Continue;
}

public Action TE_OnDecal(const char[] te_name, const Players[], int numClients, float delay)
{
	int nIndex = TE_ReadNum("m_nIndex");
	char sDecalName[13];

	ReadStringTable(g_i_DecalPrecacheTable, nIndex, sDecalName, sizeof(sDecalName));
		
	if(StrEqual(sDecalName, "decals/blood"))
		return Plugin_Handled;
	
	return Plugin_Continue;
}
public Action CheckTimelimit(Handle timer)
{
	Handle hTimer;	
	hTimer = FindConVar("mp_timelimit");
	int GameTimerLeft = GetConVarInt(hTimer);			
	if (hTimer != INVALID_HANDLE)
		CloseHandle(hTimer);	
	if (GameTimerLeft > 0)
	{
		int ncounter;
		GetMapTimeLeft(ncounter);
		
		switch(ncounter)
		{
			case 120: PrintToChatAll("Time Remaining: 2 minutes");
			case 60: PrintToChatAll("Time Remaining: 60 seconds");
			case 30: PrintToChatAll("Time Remaining: 30 seconds");
			case 15: PrintToChatAll("Time Remaining: 15 seconds");
			case -1: PrintToChatAll("3..");
			case -2: PrintToChatAll("2..");
			case -3: PrintToChatAll("1..");
		}
		
		if(ncounter < -3)
		{
			SetConVarInt(FindConVar("mp_ignore_round_win_conditions"), 0);
			CS_TerminateRound(0.5, CSRoundEnd_TerroristWin, true);
		}
	}
}
public Action Kill_weapons(Handle timer,any client)
{
		// By Kigen (c) 2008 - Please give me credit. :)
	int maxent = GetMaxEntities();
	char weapon[64];
	for (int i=GetMaxClients();i<maxent;i++)
	{
		if ( IsValidEdict(i) && IsValidEntity(i) )
		{
			GetEdictClassname(i, weapon, sizeof(weapon));
			if ( ( StrContains(weapon, "weapon_") != -1 || StrContains(weapon, "item_") != -1 ) && GetEntDataEnt2(i, g_WeaponParent) == -1 )
				RemoveEdict(i);
		}
	}	
	return Plugin_Continue;
}